; yamaha psr-40
;
; there's a whole lot of code that looks like generated from something high level,
; or macros and could have been more optimal if just left to assembler expressions:
;L0E4F:
;	ld	hl,08000H  ; probably was originally "ld hl, srambase"
;	ld	de,00009H  ; probably was originally "ld de, variable"
;	add	hl,de
;	bit	5,(hl)
;	jp	z,L0E60
;	ld	hl,X804B
;	set	2,(hl)
;L0E60:
;	ret
; instead of two 16bit literal loads and 16bit adding it could just have been a
; single 16bit load... no matter if it is ld hl,srambase+variable or just variable
; already having full address (as I don't think there is any relocatability
; involved here)
;
; following structure is used just as a wait between GE7 accesses
;	push	hl
;	pop	hl
;
; memorymap:
; 0000-7fff rom
; 8000-9fff sram 2kbyte mirroring
; a000-bfff ge7 32reg mirroring
; c000-dfff io55 4reg mirroring
; e000-ffff unused, could be someday used for midi uart
; 
; Edward dtech www.dtech.lv
;----------------------------------------
	org	00000H
;
L0000:
	di
	ld	sp,080DBH
	im	1
	ld	hl,08000H
L0009:
	dec	l
	jp	nz,L0009
	dec	h
	jp	nz,L0009
	jp	L0131
;
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	rst	L0000
	jp	L004F
;
L003B:
	ld	hl,08000H
	ld	de,08076H
L0041:
	ld	(hl),000H
	inc	hl
	ld	a,h
	cp	d
	jp	nz,L0041
	ld	a,l
	cp	e
	jp	nz,L0041
	ret
;
L004F:
	push	af
	push	bc
	push	de
	push	hl
	ld	a,(X8046)
	and	003H
	jp	z,L0061
	call	L0067
	call	L0087
L0061:
	pop	hl
	pop	de
	pop	bc
	pop	af
	ei
	ret
;
L0067:
	ld	a,(X8045)
	or	a
	jp	nz,L0073
	ld	b,048H
	jp	L0075
;
L0073:
	ld	b,060H
L0075:
	ld	hl,X803C
	inc	(hl)
	ld	a,(hl)
	and	07FH
	cp	b
	jp	nz,L0086
	ld	a,(hl)
	and	080H
	xor	080H
	ld	(hl),a
L0086:
	ret
;
L0087:
	ld	a,(X803C)
	and	07FH
	ld	de,00000H
L008F:
	inc	de
	sub	018H
	jp	nc,L008F
	add	a,018H
	ld	c,a
	ld	a,(X8046)
	bit	3,a
	jp	nz,L00AA
	bit	0,a
	jp	nz,L00BC
	ret
;
	db	001H, 002H, 004H, 000H
;
L00AA:
	ld	a,(X8045)
	or	a
	jp	nz,L00B8
	ld	a,e
	cp	003H
	jp	nz,L00B8
	inc	de
L00B8:
	dec	de
	jp	L00CC
;
L00BC:
	ld	de,00000H
	ld	a,c
	or	a
	jp	z,L00CC
	ld	de,00003H
	cp	006H
	jp	nz,L00DC
L00CC:
	ld	a,(X8044)
	and	0F8H
	ld	hl,000A6H
	add	hl,de
	ld	a,(hl)
	ld	(X8044),a
	ld	(XA01B),a    ; GE7 rhythm led
L00DC:
	ld	a,(X8046)
	bit	3,a
	jp	z,L0130
	ld	b,004H
	ld	a,(X8045)
	cp	001H
	ld	a,c
	jp	z,L00F1
	ld	b,003H
L00F1:
	sub	b
	jp	nc,L00F1
	add	a,b
	jp	nz,L0130
	ld	a,(X8048)
	ld	(XA01A),a    ; GE7 write drum triggers
	and	010H
	ld	(X8048),a
	ld	a,(X804C)
	and	003H
	jp	z,L0130
	ld	hl,X8051
	ld	a,(hl)
	ld	(XA004),a   ; GE7 write CH4 pitch
	ld	a,(X8050)
	cp	004H
	jp	z,L0130
	inc	hl
	ld	a,(hl)
	ld	(XA005),a   ; GE7 write CH5 pitch
	push	hl
	pop	hl
	inc	hl
	ld	a,(hl)
	ld	(XA006),a   ; GE7 write CH6 pitch
	push	hl
	pop	hl
	inc	hl
	ld	a,(hl)
	ld	(XA007),a   ; GE7 write CH7 pitch
	push	hl
	pop	hl
L0130:
	ret
;
L0131:
	ld	a,089H
	ld	(XC003),a
	push	hl
	pop	hl
	ld	a,001H
	ld	(XC000),a
	push	hl
	pop	hl
	ld	a,(XC002)
	bit	0,a
	jp	z,L09BF
	ld	a,080H
	ld	(XC000),a
	push	hl
	pop	hl
	ld	a,(XC002)
	bit	6,a
	jp	z,L09BF
	ld	a,001H
	ld	(XC000),a
	push	hl
	pop	hl
L015D:
	ld	a,(XC002)
	bit	0,a
	jp	nz,L015D
	ld	a,080H
	ld	(XC000),a
	push	hl
	pop	hl
L016C:
	ld	a,(XC002)
	bit	6,a
	jp	nz,L016C
	ld	b,001H
	ld	hl,08000H
L0179:
	ld	a,001H
	ld	(hl),a
L017C:
	cp	(hl)
	jp	nz,L0241
	sla	(hl)
	sla	a
	jp	nc,L017C
	cp	(hl)
	jp	nz,L0241
	ld	a,055H
	ld	(hl),a
	cp	(hl)
	jp	nz,L0241
	ld	a,0AAH
	ld	(hl),a
	cp	(hl)
	jp	nz,L0241
	ld	a,0FFH
	ld	(hl),a
	cp	(hl)
	jp	nz,L0241
	inc	hl
	ld	a,h
	cp	088H
	jp	nz,L0179
	ld	b,002H
	ld	hl,00292H
	ld	c,001H
L01AE:
	ld	a,c
	ld	(XC000),a
	push	hl
	pop	hl
	ld	a,(XC002)
	cp	(hl)
	jp	nz,L0241
	inc	hl
	sla	c
	jp	nc,L01AE
	ld	c,001H
L01C3:
	ld	a,c
	ld	(XC001),a
	push	hl
	pop	hl
	ld	a,(XC002)
	cp	(hl)
	jp	nz,L0241
	inc	hl
	sla	c
	ld	a,c
	cp	080H
	jp	nz,L01C3
	ld	(XC001),a
	push	hl
	pop	hl
	ld	a,001H
	ld	(XA01B),a    ; GE7 rhythm led
	push	hl
	pop	hl
	ld	a,080H
	ld	(XA008),a    ; GE7 write CH1 envelope
	push	hl
	pop	hl
	ld	(XA014),a    ; GE7 write CH1 sound
	push	hl
	pop	hl
L01F1:
	ld	a,004H
	ld	(XA00D),a    ; GE7 write CH1 settings
	push	hl
	pop	hl
	ld	b,000H
L01FA:
	ld	a,0C3H
	ld	(XA001),a    ; GE7 wirte CH1 pitch
	push	hl
	pop	hl
	ld	a,080H
	ld	(XC000),a
	push	hl
	pop	hl
L0208:
	ld	a,(XC002)
	cp	b
	jp	z,L0208
	ld	b,a
	bit	2,a
	jp	nz,L0227
	bit	4,a
	jp	nz,L0231
	bit	5,a
	jp	nz,L01F1
	bit	6,a
	jp	z,L0208
	jp	L0000
;
L0227:
	ld	a,043H
	ld	(XA001),a    ; GE7 wirte CH1 pitch
	push	hl
	pop	hl
	jp	L0208
;
L0231:
	xor	a
	ld	(XA001),a    ; GE7 wirte CH1 pitch
	push	hl
	pop	hl
	ld	a,044H
	ld	(XA00D),a    ; GE7 write CH1 settings
	push	hl
	pop	hl
	jp	L01FA
;
L0241:
	ld	a,080H
	ld	(XC001),a
	push	hl
	pop	hl
	ld	a,b
	cp	001H
	jp	nz,L026E
L024E:
	ld	a,001H
	ld	(XA01B),a    ; GE7 rhythm led
	ld	de,08000H
L0256:
	ld	a,(hl)
	dec	de
	ld	a,e
	or	d
	jp	nz,L0256
	xor	a
	ld	(XA01B),a    ; GE7 rhythm led
	ld	de,08000H
L0264:
	ld	a,(hl)
	dec	de
	ld	a,e
	or	d
	jp	nz,L0264
	jp	L024E
;
L026E:
	ld	a,001H
	ld	(XA01B),a    ; GE7 rhythm led
	ld	de,08000H
L0276:
	ld	a,(XC002)
	dec	de
	ld	a,e
	or	d
	jp	nz,L0276
	xor	a
	ld	(XA01B),a    ; GE7 rhythm led
	ld	de,08000H
L0286:
	ld	a,(XC002)
	dec	de
	ld	a,e
	or	d
	jp	nz,L0286
	jp	L026E
;
	db	040H, 000H, 000H, 000H
	db	000H, 000H, 000H, 000H
	db	042H, 001H, 001H, 001H
	db	001H, 001H, 021H, 000H
;
L02A2:
	pop	hl
	ex	(sp),hl
	ld	a,l
	or	a
	jp	z,L02DB
	cp	031H
	jp	c,L02B5
	sub	030H
	add	a,050H
	jp	L02DB
;
L02B5:
	cp	025H
	jp	c,L02C1
	sub	024H
	add	a,040H
	jp	L02DB
;
L02C1:
	cp	019H
	jp	c,L02CD
	sub	018H
	add	a,030H
	jp	L02DB
;
L02CD:
	cp	00DH
	jp	c,L02D9
	sub	00CH
	add	a,020H
	jp	L02DB
;
L02D9:
	add	a,010H
L02DB:
	ld	h,000H
	ld	l,a
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L02E0:                 ; write GE7 - tik jaaiekomentee input regjistrus/stackaa iegruusto. atsevishkji regjistrs, un atsevishkji dati
	pop	hl
	pop	bc
	ex	(sp),hl
	ld	a,l
	cp	019H      ; shis jociigi sanaak, ka shii routine ignoree writeus saakot no reg $19 kas kak raz saakaas peedeejaa dalja ar rhythm, irq un tehniskajiem.
	jp	nc,L02F0
	ex	de,hl
	ld	hl,0A000H
	add	hl,de
	ld	a,c
	ld	(hl),a
L02F0:
	ret
;
L02F1:
	pop	hl
	pop	de
	ex	(sp),hl
	ld	h,000H
	push	hl
	ld	a,e
	and	07FH
	jp	z,L0315
	bit	7,e
	jp	z,L030F
	ld	l,a
	push	hl
	call	L02A2
	pop	hl
	ld	a,l
	or	080H
	ld	e,a
	jp	L0315
;
L030F:
	ld	l,e
	push	hl
	call	L02A2
	pop	de
L0315:
	ld	d,000H
	push	de
	call	L02E0
	ret
;
L031C:
	ld	a,(X8036)
	cp	002H
	jp	c,L0348
	ld	de,00000H
L0327:
	push	de
	ld	hl,08025H
	add	hl,de
	ld	l,(hl)
	ld	h,000H
	push	hl
	ld	hl,0802DH
	add	hl,de
	ld	a,(hl)
	or	080H
	ld	l,a
	ld	h,000H
	push	hl
	call	L02F1
	pop	de
	inc	de
	ld	a,(X8036)
	dec	a
	cp	e
	jp	nz,L0327
L0348:
	ret
;
L0349:
	ld	a,(X8041)
	ld	e,a
	add	a,a
	add	a,e
	add	a,c
	ld	d,000H
	ld	e,a
	ld	hl,02AD1H
	add	hl,de
	ld	l,(hl)
	ld	h,000H
	ret
;
L035B:
	ld	c,000H
	call	L0349
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L0362:
	ld	c,001H
	call	L0349
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L0369:
	ld	c,002H
	call	L0349
	ld	a,l
	and	00CH
	jp	nz,L0378
	ld	a,(X8040)
	or	l
L0378:
	ld	l,a
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L037B:
	call	L035B
	pop	hl
	ld	a,l
	and	007H
	cp	005H
	jp	c,L0394
	ld	a,l
	and	070H
	cp	041H
	jp	c,L0394
	ld	a,080H
	jp	L0395
;
L0394:
	xor	a
L0395:
	ld	h,000H
	ld	l,a
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L039A:
	call	L035B
	call	L0362
	call	L0369
	pop	bc
	pop	iy
	pop	ix
	ld	de,00000H
L03AB:
	ld	hl,08025H
	add	hl,de
	ld	a,(hl)
	cp	006H
	jp	nc,L03E3
	push	ix
	push	iy
	push	bc
	push	de
	ld	hl,08025H
	add	hl,de
	ld	a,(hl)
	add	a,007H
	ld	l,a
	ld	h,000H
	push	hl
	push	ix
	call	L02E0
	pop	de
	push	de
	ld	hl,08025H
	add	hl,de
	ld	a,(hl)
	add	a,013H
	ld	l,a
	ld	h,000H
	push	hl
	push	iy
	call	L02E0
	pop	de
	pop	bc
	pop	iy
	pop	ix
L03E3:
	push	ix
	push	iy
	push	bc
	push	de
	ld	hl,08025H
	add	hl,de
	ld	a,(hl)
	add	a,00CH
	ld	l,a
	ld	h,000H
	push	hl
	push	bc
	call	L02E0
	pop	de
	pop	bc
	pop	iy
	pop	ix
	inc	de
	ld	a,(X8037)
	cp	e
	jp	nz,L03AB
	ld	hl,X8039
	bit	0,(hl)
	jp	z,L0418
	ld	a,(X8038)
	ld	l,a
	ld	h,000H
	push	hl
	call	L280B
L0418:
	ret
;
L0419:
	call	L037B
	pop	hl
	ld	a,(X8036)
	cp	002H
	jp	c,L0445
	ld	de,00000H
L0428:
	push	de
	push	hl
	ld	a,l
	ld	hl,08025H
	add	hl,de
	ld	l,(hl)
	ld	h,000H
	push	hl
	ld	l,a
	ld	h,000H
	push	hl
	call	L02E0
	pop	hl
	pop	de
	inc	de
	ld	a,(X8036)
	dec	a
	cp	e
	jp	nz,L0428
L0445:
	ld	a,(X8037)
	ld	b,a
	ld	a,(X8036)
	cp	b
	jp	z,L0456
	jp	c,L0456
	jp	L0473
;
L0456:
	dec	a
	ld	e,a
	ld	d,000H
L045A:
	push	de
	ld	hl,08025H
	add	hl,de
	ld	l,(hl)
	ld	h,000H
	push	hl
	ld	hl,00000H
	push	hl
	call	L02E0
	pop	de
	inc	de
	ld	a,(X8037)
	cp	e
	jp	nz,L045A
L0473:
	call	L039A
	call	L031C
	ret
;
L047A:
	pop	hl
	ex	(sp),hl
	ex	de,hl
	ld	hl,08000H
	add	hl,de
	ld	a,(hl)
	ld	hl,0800FH
	add	hl,de
	and	(hl)
	ld	h,000H
	ld	l,a
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L048C:
	ld	b,0FFH
	ld	c,000H
	ld	de,00008H
L0493:
	ld	hl,0800FH
	add	hl,de
	ld	a,(hl)
	and	0C0H
	or	c
	ld	c,a
	inc	de
	ld	a,e
	cp	00CH
	jp	nz,L0493
	ld	a,c
	or	a
	jp	nz,L04B4
	ld	hl,0800FH
	ld	de,00005H
	add	hl,de
	bit	7,(hl)
	jp	z,L04F4
L04B4:
	ld	de,0000CH
L04B7:
	dec	de
	ld	a,e
	sub	008H
	sla	a
	sla	a
	ld	hl,08000H
	add	hl,de
	bit	7,(hl)
	jp	z,L04CD
	add	a,002H
	jp	L04D2
;
L04CD:
	bit	6,(hl)
	jp	z,L04D3
L04D2:
	ld	b,a
L04D3:
	ld	a,e
	cp	008H
	jp	z,L04DF
	ld	a,b
	cp	0FFH
	jp	z,L04B7
L04DF:
	ld	a,b
	cp	0FFH
	jp	nz,L04E7
	ld	b,000H
L04E7:
	ld	hl,08000H
	ld	de,00005H
	add	hl,de
	bit	7,(hl)
	jp	z,L04F4
	inc	b
L04F4:
	ld	a,b
	cp	0FFH
	jp	z,L0500
	ld	(X8041),a
	call	L0419
L0500:
	ret
;
L0501:
	call	L0369
	pop	bc
	ld	de,00000H
L0508:
	push	de
	push	bc
	ld	hl,08025H
	add	hl,de
	ld	a,(hl)
	add	a,00CH
	ld	l,a
	ld	h,000H
	push	hl
	push	bc
	call	L02E0
	pop	bc
	pop	de
	inc	de
	ld	a,(X8037)
	cp	e
	jp	nz,L0508
	ld	hl,X8039
	bit	0,(hl)
	jp	z,L053E
	ld	a,(X8038)
	add	a,00CH
	ld	l,a
	ld	h,000H
	push	hl
	ld	a,c
	or	012H
	ld	l,a
	ld	h,000H
	push	hl
	call	L02E0
L053E:
	ret
;
L053F:
	ld	hl,0800FH
	ld	de,00006H
	add	hl,de
	ld	a,(hl)
	and	0C0H
	ld	c,a
	ld	hl,08000H
	ld	de,00006H
	add	hl,de
	ld	a,(hl)
	and	0C0H
	ld	b,a
	ld	a,c
	cp	000H
	jp	z,L057D
	bit	6,b
	jp	z,L0568
	ld	a,008H
	ld	(X8040),a
	jp	L057A
;
L0568:
	bit	7,b
	jp	z,L0575
	ld	a,004H
	ld	(X8040),a
	jp	L057A
;
L0575:
	ld	a,000H
	ld	(X8040),a
L057A:
	call	L0501
L057D:
	ret
;
L057E:
	ld	hl,0800FH
	ld	de,0000BH
	add	hl,de
	bit	5,(hl)
	jp	z,L05A3
	ld	hl,08000H
	ld	de,0000BH
	add	hl,de
	bit	5,(hl)
	jp	z,L059E
	ld	hl,X8039
	set	4,(hl)
	jp	L05A3
;
L059E:
	ld	hl,X8039
	res	4,(hl)
L05A3:
	ret
;
L05A4:
	call	L048C
	call	L053F
	call	L057E
	ret
;
L05AE:
	pop	hl
	ex	(sp),hl
	ld	h,000H
	ld	de,00001H
	ld	c,000H
L05B7:
	ld	a,(X8036)
	cp	e
	jp	z,L05E0
	jp	c,L05E0
	ld	a,c
	or	a
	jp	nz,L05E0
	push	hl
	ld	a,l
	ld	hl,0802DH
	add	hl,de
	dec	hl
	cp	(hl)
	jp	nz,L05DB
	ld	hl,08025H
	add	hl,de
	dec	hl
	ld	c,(hl)
	pop	hl
	jp	L05B7
;
L05DB:
	pop	hl
	inc	de
	jp	L05B7
;
L05E0:
	ld	a,c
	or	a
	jp	z,L0632
	ld	a,l
	push	hl
	push	de
	push	bc
	ld	hl,08025H
	add	hl,de
	dec	hl
	ld	l,(hl)
	ld	h,000H
	push	hl
	ld	l,a
	ld	h,000H
	push	hl
	call	L02F1
	pop	bc
	pop	de
	pop	hl
L05FC:
	ld	a,(X8037)
	cp	e
	jp	z,L061A
	jp	c,L061A
	push	hl
	ld	hl,08025H
	add	hl,de
	ld	a,(hl)
	dec	hl
	ld	(hl),a
	ld	hl,0802DH
	add	hl,de
	ld	a,(hl)
	dec	hl
	ld	(hl),a
	inc	de
	pop	hl
	jp	L05FC
;
L061A:
	push	hl
	ld	hl,08025H
	ld	a,(X8037)
	ld	e,a
	ld	d,000H
	add	hl,de
	dec	hl
	ld	(hl),c
	ld	hl,0802DH
	add	hl,de
	dec	hl
	pop	bc
	ld	(hl),c
	ld	hl,X8036
	dec	(hl)
L0632:
	ret
;
L0633:
	pop	hl
	ex	(sp),hl
	ld	c,l
	ld	de,00001H
	ld	b,0FFH
L063B:
	ld	a,(X8036)
	cp	e
	jp	z,L065C
	jp	c,L065C
	ld	hl,0802DH
	add	hl,de
	dec	hl
	ld	a,(hl)
	cp	c
	jp	nz,L0658
	ld	b,000H
	ld	a,(X8036)
	ld	e,a
	jp	L063B
;
L0658:
	inc	e
	jp	L063B
;
L065C:
	ld	l,b
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L0661:
	pop	hl
	ex	(sp),hl
	ld	h,000H
	push	hl
	push	hl
	call	L0633
	pop	hl
	ld	a,l
	cp	0FFH
	pop	hl
	jp	nz,L071F
	ld	a,(X8036)
	ld	b,a
	ld	a,(X8037)
	cp	b
	jp	c,L071F
	ld	a,(X8036)
	ld	e,a
	ld	d,000H
	ld	c,000H
L0685:
	push	hl
	ld	hl,0802DH
	add	hl,de
	dec	hl
	ld	a,(hl)
	pop	hl
	cp	l
	jp	nz,L069C
	push	hl
	ld	hl,08025H
	add	hl,de
	dec	hl
	ld	c,(hl)
	pop	hl
	jp	L069D
;
L069C:
	inc	de
L069D:
	ld	a,(X8037)
	cp	e
	jp	c,L06A9
	ld	a,c
	or	c
	jp	z,L0685
L06A9:
	ld	a,c
	or	c
	jp	z,L06F5
	push	hl
	push	de
	push	bc
	ld	b,000H
	push	bc
	ld	c,000H
	push	bc
	call	L02E0
	pop	bc
	pop	de
	pop	hl
L06BD:
	ld	a,(X8036)
	cp	e
	jp	nc,L06DC
	push	hl
	ld	hl,08025H
	add	hl,de
	dec	hl
	dec	hl
	ld	a,(hl)
	inc	hl
	ld	(hl),a
	ld	hl,0802DH
	add	hl,de
	dec	hl
	dec	hl
	ld	a,(hl)
	inc	hl
	ld	(hl),a
	dec	de
	pop	hl
	jp	L06BD
;
L06DC:
	push	hl
	ld	hl,08025H
	ld	a,(X8036)
	ld	e,a
	ld	d,000H
	add	hl,de
	dec	hl
	ld	(hl),c
	ld	hl,0802DH
	add	hl,de
	dec	hl
	ex	de,hl
	pop	hl
	ld	a,l
	ld	(de),a
	jp	L071B
;
L06F5:
	push	hl
	ld	hl,08025H
	ld	a,(X8036)
	ld	e,a
	ld	d,000H
	add	hl,de
	dec	hl
	ld	l,(hl)
	ld	h,000H
	push	hl
	ld	hl,00000H
	push	hl
	call	L02E0
	ld	hl,0802DH
	ld	a,(X8036)
	ld	e,a
	ld	d,000H
	add	hl,de
	dec	hl
	ex	de,hl
	pop	hl
	ld	a,l
	ld	(de),a
L071B:
	ld	hl,X8036
	inc	(hl)
L071F:
	ret
;
L0720:
	ld	a,089H
	ld	(XC003),a
	push	hl
	pop	hl
	xor	a
	ld	(XC000),a
	push	hl
	pop	hl
	ld	a,080H
	ld	(XC001),a
	call	L003B
	ld	de,00000H
L0738:
	ld	hl,08025H
	add	hl,de
	ld	a,e
	inc	a
	ld	(hl),a
	inc	de
	ld	a,e
	cp	007H
	jp	nz,L0738
	ld	a,001H
	ld	(X8036),a
	ld	a,007H
	ld	(X8037),a
	ld	a,006H
	ld	(X8035),a
	call	L039A
	ld	a,010H
	ld	(X8048),a
	ld	a,001H
	ld	(X8045),a
	ret
;
L0763:
	ld	a,055H
	ld	(XC000),a
	push	hl
	pop	hl
	ld	a,0AAH
	ld	(XC001),a
	push	hl
	pop	hl
	ld	a,(XC000)
	push	hl
	pop	hl
	cp	055H
	jp	nz,L0783
	ld	a,(XC001)
	cp	0AAH
	jp	z,L078B
L0783:
	di
	call	L0720
	ei
	jp	L0796
;
L078B:
	xor	a
	ld	(XC000),a
	push	hl
	pop	hl
	ld	a,080H
	ld	(XC001),a
L0796:
	ret
;
L0797:
	ld	a,000H
	ld	(X801E),a
	ld	(X801F),a
	ld	(X8020),a
	ld	(X8021),a
	ld	a,(X8046)
	and	088H
	cp	088H
	jp	nz,L07B4
	ld	a,001H
	jp	L07B5
;
L07B4:
	xor	a
L07B5:
	ld	(X8024),a
	ld	a,(X8046)
	and	00FH
	ld	(X8046),a
	ld	a,(X804C)
	and	00FH
	ld	(X804C),a
	ret
;
L07C9:
	ld	a,(XC002)
	ld	c,a
	ld	d,(ix+000H)
	xor	d
	ld	d,a
	ld	(ix+000H),c
	ld	(iy+000H),d
	ret
;
L07D9:
	ld	ix,08000H
	ld	iy,0800FH
	ld	b,001H
	ld	e,000H
L07E5:
	ld	a,b
	ld	(XC000),a
	push	hl
	pop	hl
	call	L07C9
	sla	b
	inc	ix
	inc	iy
	inc	e
	ld	a,e
	cp	008H
	jp	nz,L07E5
	ld	a,000H
	ld	(XC000),a
	ld	b,001H
L0802:
	ld	a,b
	or	080H
	ld	(XC001),a
	push	hl
	pop	hl
	call	L07C9
	sla	b
	inc	ix
	inc	iy
	inc	e
	ld	a,e
	cp	00FH
	jp	nz,L0802
	ld	a,080H
	ld	(XC001),a
	ret
;
L0820:
	call	L0D3C
	call	L13FD
	call	L05A4
	ret
;
L082A:
	ld	c,000H
	ld	b,007H
	ld	hl,0800FH
	ld	hl,0800FH
L0834:
	ld	a,(hl)
	and	03FH
	or	c
	ld	c,a
	inc	hl
	djnz	L0834
	ld	a,(hl)
	and	07FH
	or	c
	jp	z,L0848
	ld	a,0FFH
	ld	(X801E),a
L0848:
	ld	de,00005H
	ld	ix,08000H
	add	ix,de
	ld	iy,0800FH
	add	iy,de
	ld	b,000H
	ld	c,000H
	ld	d,000H
	ld	e,005H
L085F:
	ld	a,(ix+000H)
	and	03FH
	or	b
	ld	b,a
	ld	a,(iy+000H)
	and	03FH
	or	c
	ld	c,a
	push	iy
	push	ix
	push	bc
	push	de
	ld	d,000H
	push	de
	call	L047A
	pop	de
	ld	a,e
	and	03FH
	pop	de
	or	d
	ld	d,a
	pop	bc
	pop	ix
	pop	iy
	inc	ix
	inc	iy
	inc	e
	ld	a,e
	cp	007H
	jp	nz,L085F
	ld	a,(ix+000H)
	and	07FH
	or	b
	ld	b,a
	ld	a,(iy+000H)
	and	07FH
	or	c
	ld	c,a
	push	bc
	push	de
	ld	hl,00007H
	push	hl
	call	L047A
	pop	hl
	ld	a,l
	and	07FH
	pop	de
	pop	bc
	or	d
	ld	d,a
	ld	a,b
	or	a
	jp	z,L08B9
	ld	a,0FFH
	ld	(X801F),a
L08B9:
	ld	a,c
	or	a
	jp	z,L08C3
	ld	a,0FFH
	ld	(X8020),a
L08C3:
	ld	a,d
	or	a
	jp	z,L08CD
	ld	a,0FFH
	ld	(X8021),a
L08CD:
	ret
;
L08CE:
	ld	c,036H
	ld	b,000H
	ld	ix,08000H
	ld	iy,0800FH
L08DA:
	ld	d,(ix+000H)
	ld	e,(iy+000H)
	ld	a,d
	cpl
	and	e
	ld	d,a
	ld	a,b
	cp	007H
	jp	nz,L08F3
	ld	a,d
	and	07FH
	ld	d,a
	ld	e,007H
	jp	L08F9
;
L08F3:
	ld	a,d
	and	03FH
	ld	d,a
	ld	e,006H
L08F9:
	ld	a,d
	or	a
	jp	z,L091C
	bit	0,d
	jp	z,L0915
	push	ix
	push	iy
	push	bc
	push	de
	ld	b,000H
	push	bc
	call	L05AE
	pop	de
	pop	bc
	pop	iy
	pop	ix
L0915:
	srl	d
	dec	c
	dec	e
	jp	L08F9
;
L091C:
	ld	a,c
	sub	e
	ld	c,a
	inc	b
	inc	ix
	inc	iy
	ld	a,(X8035)
	cp	c
	jp	z,L08DA
	jp	c,L08DA
	ret
;
L092F:
	ld	c,036H
	ld	b,000H
	ld	ix,08000H
	ld	iy,0800FH
L093B:
	ld	a,b
	cp	007H
	jp	nz,L094C
	ld	a,(ix+000H)
	and	07FH
	ld	d,a
	ld	e,007H
	jp	L0954
;
L094C:
	ld	a,(ix+000H)
	and	03FH
	ld	d,a
	ld	e,006H
L0954:
	ld	a,d
	or	a
	jp	z,L0977
	bit	0,d
	jp	z,L0970
	push	ix
	push	iy
	push	bc
	push	de
	ld	b,000H
	push	bc
	call	L0661
	pop	de
	pop	bc
	pop	iy
	pop	ix
L0970:
	srl	d
	dec	c
	dec	e
	jp	L0954
;
L0977:
	ld	a,c
	sub	e
	ld	c,a
	inc	b
	inc	ix
	inc	iy
	ld	a,(X8035)
	cp	c
	jp	z,L093B
	jp	c,L093B
	ret
;
L098A:
	call	L08CE
	call	L092F
	call	L031C
	ret
;
L0994:
	ld	a,(XA01E)  ; GE7 read "inital clear" register. however, initial clear is bit0, so it could be IRQ ack or something.
	bit	2,a
	jp	z,L09A1
	ld	b,080H
	jp	L09A3
;
L09A1:
	ld	b,000H
L09A3:
	ld	hl,X8044
	ld	a,(hl)
	and	080H
	cp	b
	jp	z,L09BE
	ld	a,(hl)
	and	07FH
	or	b
	ld	(hl),a
	ld	a,(X8046)
	and	003H
	jp	nz,L09BE
	ld	a,(hl)
	ld	(XA01B),a    ; GE7 rhythm led
L09BE:
	ret
;
L09BF:
	call	L0720
	ei
L09C3:
	call	L0763
	call	L0797
	call	L07D9
	ld	a,(X8046)
	bit	3,a
	jp	z,L09D7
	call	L0B37
L09D7:
	call	L0820
	ld	a,(X804C)
	and	030H
	jp	z,L09E5
	call	L1459
L09E5:
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	jp	z,L09FC
	ld	a,(X8039)
	bit	4,a
	jp	z,L09FC
	call	L288F
	jp	L09FF
;
L09FC:
	call	L28B5
L09FF:
	call	L082A
	call	L0D46
	call	L0DC1
	call	L0E61
	ld	a,(X803D)
	bit	0,a
	jp	z,L0A25
	ld	a,(X8024)
	and	063H
	jp	z,L0A25
	ld	a,(X803E)
	ld	h,000H
	ld	l,a
	push	hl
	call	L0EA2
L0A25:
	ld	a,(X8046)
	and	030H
	jp	z,L0A30
	call	L17F0
L0A30:
	ld	a,(X804C)
	ld	b,a
	and	011H
	cp	011H
	jp	z,L0A43
	ld	a,b
	and	022H
	cp	022H
	jp	nz,L0A4D
L0A43:
	ld	a,(X801F)
	or	a
	jp	z,L0A4D
	call	L17BF
L0A4D:
	ld	a,(X801E)
	or	a
	jp	nz,L0A5A
	call	L0FA2
	jp	L0A70
;
L0A5A:
	call	L098A
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	jp	z,L0A70
	ld	a,(X8021)
	or	a
	jp	z,L0A70
	call	L17BF
L0A70:
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	jp	z,L0A7C
	call	L2736
L0A7C:
	ld	a,(X801E)
	or	a
	jp	z,L0A8E
	ld	a,(X8039)
	bit	0,a
	jp	z,L0A8E
	call	L2A45
L0A8E:
	call	L0FEC
	call	L0994
	jp	L09C3
;
L0A97:
	pop	hl
	ex	(sp),hl
	ld	a,l
	ld	l,004H
L0A9C:
	bit	4,a
	jp	nz,L0AA6
	rla
	dec	l
	jp	L0A9C
;
L0AA6:
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L0AAA:
	pop	hl
	ex	(sp),hl
	push	hl
	call	L0A97
	pop	hl
	ld	a,l
	or	a
	jp	nz,L0ABB
	ld	a,007H
	jp	L0ABE
;
L0ABB:
	ld	a,004H
	sub	l
L0ABE:
	ld	h,000H
	ld	l,a
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L0AC3:
	ld	a,(X8045)
	cp	002H
	jp	nz,L0AD1
	ld	hl,0001FH
	jp	L0AD4
;
L0AD1:
	ld	hl,00017H
L0AD4:
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L0AD6:
	xor	a
	ld	(X803D),a
	ld	(X803C),a
	call	L0AC3
	pop	hl
	ld	a,l
	ld	(X803F),a
	ld	a,001H
	ld	(X803E),a
	ret
;
L0AEB:
	ld	a,(X8046)
	and	088H
	cp	088H
	jp	nz,L0AFB
	ld	hl,000FFH
	jp	L0AFE
;
L0AFB:
	ld	hl,00000H
L0AFE:
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L0B00:
	pop	hl
	ex	(sp),hl
	ex	de,hl
	ld	a,(X8046)
	bit	3,a
	jp	z,L0B36
	di
	ld	hl,X803C
	ld	a,(hl)
	and	07FH
	cp	018H
	jp	c,L0B35
	ld	a,e
	or	a
	jp	nz,L0B2A
	ld	a,(X8045)
	or	a
	jp	z,L0B35
	ld	a,(hl)
	add	a,018H
	ld	(hl),a
	jp	L0B35
;
L0B2A:
	ld	a,(X8045)
	or	a
	jp	nz,L0B35
	ld	a,(hl)
	sub	018H
	ld	(hl),a
L0B35:
	ei
L0B36:
	ret
;
L0B37:
	ld	a,(X803C)
	ld	c,a
	ld	a,c
	and	080H
	ld	b,a
	ld	a,c
	and	07FH
	ld	c,a
	ld	a,(X8045)
	cp	001H
	jp	nz,L0B55
	ld	a,c
	srl	a
	srl	a
	add	a,b
	ld	b,a
	jp	L0B63
;
L0B55:
	push	bc
	ld	h,000H
	ld	l,c
	ld	de,00003H
	call	L5F3B
	pop	bc
	ld	a,l
	add	a,b
	ld	b,a
L0B63:
	ld	a,(X803D)
	cp	b
	jp	z,L0BA5
	ld	a,(X803D)
	ld	(X803F),a
	ld	a,b
	ld	(X803D),a
	inc	a
	ld	(X803E),a
	and	07FH
	ld	c,a
	push	bc
	call	L0AC3
	pop	hl
	pop	bc
	ld	a,l
	inc	a
	ld	b,a
	ld	a,c
	cp	b
	jp	c,L0B9D
	sub	b
	ld	(X803E),a
	ld	a,(X803D)
	bit	7,a
	jp	nz,L0B9D
	ld	a,(X803E)
	set	7,a
	ld	(X803E),a
L0B9D:
	ld	a,(X8024)
	set	0,a
	ld	(X8024),a
L0BA5:
	ret
;
L0BA6:
	pop	hl
	ex	(sp),hl
	ld	h,000H
	ld	a,l
	ld	(X8047),a
	ld	a,(X8045)
	ld	b,a
	ld	a,l
	ld	c,000H
	cp	013H
	jp	z,L0BDC
	ld	c,001H
	cp	000H
	jp	z,L0BDC
	cp	001H
	jp	z,L0BDC
	cp	003H
	jp	z,L0BDC
	cp	004H
	jp	z,L0BDC
	cp	005H
	jp	z,L0BDC
	cp	012H
	jp	z,L0BDC
	ld	c,002H
L0BDC:
	ld	a,c
	ld	(X8045),a
	ld	l,b
	ld	h,000H
	push	hl
	call	L0B00
	call	L0B37
	ld	hl,X8024
	set	5,(hl)
	ret
;
L0BF0:
	ld	hl,X8046
	bit	2,(hl)
	jp	z,L0BFE
	ld	a,040H
	ld	(hl),a
	jp	L0C11
;
L0BFE:
	bit	1,(hl)
	jp	z,L0C09
	ld	a,020H
	ld	(hl),a
	jp	L0C11
;
L0C09:
	bit	0,(hl)
	jp	z,L0C11
	ld	a,010H
	ld	(hl),a
L0C11:
	ld	a,(X8044)
	and	080H
	ld	(X8044),a
	ld	(XA01B),a    ; GE7 rhythm led
	xor	a
	ld	(X804A),a
	ld	(X804B),a
	ret
;
L0C24:
	ld	hl,X8046
	bit	3,(hl)
	jp	nz,L0C31
	ld	a,0AAH
	jp	L0C36
;
L0C31:
	ld	a,(hl)
	and	088H
	or	002H
L0C36:
	ld	(hl),a
	ret
;
L0C38:
	ld	hl,X8046
	bit	3,(hl)
	jp	nz,L0C45
	bit	0,(hl)
	jp	nz,L0C48
L0C45:
	ld	a,011H
	ld	(hl),a
L0C48:
	ret
;
L0C49:
	ld	hl,00008H
	push	hl
	call	L047A
	pop	hl
	ld	a,l
	and	03EH
	rrca
	or	a
	jp	z,L0C65
	ld	l,a
	ld	h,000H
	push	hl
	call	L0AAA
	pop	hl
	ld	a,l
	ld	(XA019),a   ; GE7 write rhythm volume
L0C65:
	ret
;
L0C66:
	ld	b,0FFH
	ld	c,000H
	ld	e,000H
	ld	hl,0800FH
L0C6F:
	ld	a,(hl)
	and	0C0H
	or	c
	ld	c,a
	ld	a,e
	cp	004H
	jp	z,L0C7F
	inc	e
	inc	hl
	jp	L0C6F
;
L0C7F:
	ld	a,c
	or	a
	jp	nz,L0C90
	ld	hl,0800FH
	ld	de,00005H
	add	hl,de
	bit	6,(hl)
	jp	z,L0CD4
L0C90:
	ld	de,00005H
	ld	hl,08000H
	add	hl,de
L0C97:
	dec	e
	dec	hl
	bit	7,(hl)
	jp	z,L0CA9
	ld	a,e
	sla	a
	sla	a
	add	a,002H
	ld	b,a
	jp	L0CB4
;
L0CA9:
	bit	6,(hl)
	jp	z,L0CB4
	ld	a,e
	sla	a
	sla	a
	ld	b,a
L0CB4:
	ld	a,e
	or	a
	jp	z,L0CBF
	ld	a,b
	cp	0FFH
	jp	z,L0C97
L0CBF:
	ld	a,b
	cp	0FFH
	jp	nz,L0CC7
	ld	b,000H
L0CC7:
	ld	hl,08000H
	ld	de,00005H
	add	hl,de
	bit	6,(hl)
	jp	z,L0CD4
	inc	b
L0CD4:
	ld	a,b
	cp	0FFH
	jp	z,L0CE6
	ld	hl,X8024
	set	5,(hl)
	ld	l,b
	ld	h,000H
	push	hl
	call	L0BA6
L0CE6:
	ret
;
L0CE7:
	ld	hl,0000DH
	push	hl
	call	L047A
	pop	hl
	ld	a,l
	and	0E0H
	ld	c,a
	ld	b,000H
	or	a
	jp	z,L0D17
	bit	7,c
	jp	z,L0D04
	call	L0BF0
	jp	L0D17
;
L0D04:
	bit	6,c
	jp	z,L0D0F
	call	L0C24
	jp	L0D17
;
L0D0F:
	bit	5,c
	jp	z,L0D17
	call	L0C38
L0D17:
	ld	hl,0000EH
	push	hl
	call	L047A
	pop	hl
	ld	a,l
	and	0E0H
	srl	a
	srl	a
	srl	a
	srl	a
	srl	a
	jp	z,L0D3B
	ld	l,a
	ld	h,000H
	push	hl
	call	L0A97
	pop	hl
	ld	a,l
	ld	(X8049),a
L0D3B:
	ret
;
L0D3C:
	call	L0C49
	call	L0C66
	call	L0CE7
	ret
;
L0D46:
	ld	hl,0000CH
	push	hl
	call	L047A
	pop	hl
	ld	a,(X8046)
	and	009H
	cp	001H
	jp	nz,L0D6D
	ld	a,(X801F)
	cp	0FFH
	jp	z,L0D65
	bit	5,l
	jp	z,L0D6D
L0D65:
	ld	a,(X8046)
	or	088H
	ld	(X8046),a
L0D6D:
	ret
;
L0D6E:
	ld	a,001H
	ld	(X804A),a
	ld	a,(X803D)
	bit	0,a
	ret	z
	ld	hl,X8024
	set	1,(hl)
	ret
;
L0D7F:
	push	bc
	call	L0AC3
	pop	hl
	pop	bc
	ld	a,l
	sub	002H
	cp	c
	jp	z,L0DAF
	jp	c,L0DAF
	ld	hl,0000CH
	push	hl
	call	L047A
	pop	bc
	bit	5,c
	jp	z,L0DC0
	ld	hl,X804A
	bit	0,(hl)
	jp	z,L0DA9
	ld	(hl),000H
	jp	L0DC0
;
L0DA9:
	call	L0D6E
	jp	L0DC0
;
L0DAF:
	ld	hl,08000H
	ld	de,0000CH
	add	hl,de
	bit	5,(hl)
	jp	z,L0DC0
	ld	hl,X804A
	set	1,(hl)
L0DC0:
	ret
;
L0DC1:
	ld	hl,X8046
	bit	3,(hl)
	jp	z,L0DFD
	ld	a,(X803D)
	and	07FH
	ld	c,a
	push	bc
	call	L0AC3
	pop	hl
	pop	bc
	ld	a,l
	cp	c
	jp	nz,L0DF7
	ld	hl,X8024
	bit	0,(hl)
	jp	z,L0DE7
	ld	hl,X804A
	srl	(hl)
L0DE7:
	ld	hl,0000CH
	push	hl
	call	L047A
	pop	hl
	bit	5,l
	call	nz,L0D6E
	jp	L0E0F
;
L0DF7:
	call	L0D7F
	jp	L0E0F
;
L0DFD:
	ld	hl,0000CH
	push	hl
	call	L047A
	pop	hl
	bit	5,l
	jp	z,L0E0F
	ld	a,001H
	ld	(X804A),a
L0E0F:
	ret
;
L0E10:
	push	bc
	call	L0AC3
	pop	hl
	pop	bc
	ld	a,l
	sub	002H
	cp	c
	jp	z,L0E4F
	jp	c,L0E4F
	push	bc
	ld	hl,00009H
	push	hl
	call	L047A
	pop	hl
	pop	bc
	ld	b,l
	bit	5,b
	jp	z,L0E38
	ld	hl,X804B
	set	1,(hl)
	jp	L0E60
;
L0E38:
	ld	hl,X804B
	bit	0,(hl)
	jp	z,L0E60
	ld	a,c
	cp	005H
	jp	z,L0E60
	jp	c,L0E60
	call	L0BF0
	jp	L0E60
;
L0E4F:
	ld	hl,08000H
	ld	de,00009H
	add	hl,de
	bit	5,(hl)
	jp	z,L0E60
	ld	hl,X804B
	set	2,(hl)
L0E60:
	ret
;
L0E61:
	ld	hl,X8046
	bit	3,(hl)
	jp	z,L0EA1
	ld	a,(X803D)
	and	07FH
	ld	c,a
	push	bc
	call	L0AC3
	pop	hl
	pop	bc
	ld	a,l
	cp	c
	jp	nz,L0E9B
	ld	hl,X8024
	bit	0,(hl)
	jp	z,L0E87
	ld	hl,X804B
	srl	(hl)
L0E87:
	ld	hl,08000H
	ld	de,00009H
	add	hl,de
	bit	5,(hl)
	jp	z,L0EA1
	ld	hl,X804B
	set	1,(hl)
	jp	L0EA1
;
L0E9B:
	call	L0E10
	jp	L0EA1
L0EA1:
	ret
;
L0EA2:
	pop	hl
	ex	(sp),hl
	ld	e,l
	ld	hl,X804B
	bit	0,(hl)
	jp	z,L0EC3
	ld	a,e
	and	07FH
	jp	z,L0EBB
	ld	a,000H
	ld	(X8048),a
	jp	L0F45
;
L0EBB:
	ld	a,018H
	ld	(X8048),a
	jp	L0F45
;
L0EC3:
	ld	a,e
	and	07FH
	srl	a
	ld	b,a
	ld	hl,X804A
	bit	0,(hl)
	jp	z,L0F05
	ld	ix,0339BH
	ld	a,(X8049)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,00F46H
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X8047)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,00F4CH
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	e,b
	ld	d,000H
	add	ix,de
	ld	a,(ix+000H)
	ld	(X8048),a
	jp	L0F45
;
L0F05:
	bit	7,e
	jp	z,L0F13
	ld	a,(X8047)
	add	a,014H
	ld	c,a
	jp	L0F17
;
L0F13:
	ld	a,(X8047)
	ld	c,a
L0F17:
	ld	ix,02C1BH  ; points into rhythm pattern table beginning
	ld	a,(X8049)
	sla	a          ; shift left for 16bit
	ld	e,a
	ld	d,000H
	ld	hl,00F9CH  ; offset into lookup here
	add	hl,de
	ld	e,(hl)     ; 16bit lookup into de
	inc	hl
	ld	d,(hl)
	add	ix,de      ; ix tagadin ir lookuuposhanai preciizaa adrese offsetaa ritmu tabulaa
	ld	e,c        ; no >c< tad lookupo lielajaa 40-ierakstu tabulaa
	sla	e          ; shift left for 16bit
	ld	d,000H
	ld	hl,00F4CH  ; offset into another lookup here
	add	hl,de
	ld	e,(hl)     ; 16bit lookup into de
	inc	hl
	ld	d,(hl)
	add	ix,de      ; ix tagadin pieskaitaas veel viens offsets preciizajai adresei
	ld	e,b        ; no >b< tad ir offsets beatam tajaa tabulaa
	ld	d,000H
	add	ix,de      ; pieskaitam to minor offsetu un gatavs lookup
	ld	a,(ix+000H)
	ld	(X8048),a
L0F45:
	ret
;
	db	000H, 000H, 040H, 001H ; kaut kaadi 3 selekteejami major offseti visam tam kas zemaak
	db	080H, 002H
; this is 00F4CH
        db      000H, 000H   ; total 40x2byte 16bit intel formaataa adreses rhythm pattern offsets
	db	010H, 000H, 020H, 000H
	db	030H, 000H, 040H, 000H
	db	050H, 000H, 060H, 000H
	db	070H, 000H, 080H, 000H
	db	090H, 000H, 0A0H, 000H
	db	0B0H, 000H, 0C0H, 000H
	db	0D0H, 000H, 0E0H, 000H
	db	0F0H, 000H, 000H, 001H
	db	010H, 001H, 020H, 001H
	db	030H, 001H, 040H, 001H
	db	050H, 001H, 060H, 001H
	db	070H, 001H, 080H, 001H
	db	090H, 001H, 0A0H, 001H
	db	0B0H, 001H, 0C0H, 001H
	db	0D0H, 001H, 0E0H, 001H
	db	0F0H, 001H, 000H, 002H
	db	010H, 002H, 020H, 002H
	db	030H, 002H, 040H, 002H
	db	050H, 002H, 060H, 002H
	db	070H, 002H
; this is 00F9CH
        db      000H, 000H      ; intel16bit 2 kaut kaadi major offseti visam tam kas zemaak uz alternatiivu tabulu
	db	080H, 002H
        db      000H, 005H
;
L0FA2:
	ld	a,(XA01F)
	or	a
	jp	z,L0FD7
	ld	e,a
	ld	d,000H
	ld	a,(X803B)
	cp	e
	jp	z,L0FD7
	cp	e
	jp	nc,L0FBE
	ld	c,a
	ld	a,e
	sub	c
	ld	b,a
	jp	L0FC0
;
L0FBE:
	sub	e
	ld	b,a
L0FC0:
	ld	a,b
	and	0FEH
	or	a
	jp	z,L0FD7
	ld	a,e
	ld	(X803B),a
	ld	hl,00BF2H
	ld	d,000H
	call	L5F3B
	ld	a,l
	ld	(XA01D),a    ; GE7 write IRQ speed control
L0FD7:
	ret
;
L0FD8:
	ld	a,(X8048)
	ld	(XA01A),a    ; GE7 write drum triggers
	push	hl
	pop	hl
	ld	a,(X8044)
	or	001H
	ld	(XA01B),a    ; GE7 rhythm led
	call	L0AD6
	ret
;
L0FEC:
	ld	a,(X8046)
	and	011H
	cp	011H
	jp	nz,L0FFE
	ld	a,010H
	ld	(X8048),a
	call	L0FD8
L0FFE:
	call	L0AEB
	pop	hl
	ld	a,l
	or	a
	jp	z,L102C
	xor	a
	ld	(X8048),a
	call	L0FD8
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	jp	z,L101A
	call	L1A23
L101A:
	ld	hl,00000H
	push	hl
	call	L0EA2
	ld	a,(X8048)
	ld	(XA01A),a    ; GE7 write drum triggers
	and	010H
	ld	(X8048),a
L102C:
	ret
;
L102D:
	ld	a,(X8042)
	ld	e,a
	add	a,a
	add	a,e
	add	a,c
	ld	d,000H
	ld	e,a
	ld	hl,02B01H
	add	hl,de
	ld	l,(hl)
	ld	h,000H
	ret
;
L103F:
	ld	c,000H
	call	L102D
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L1046:
	ld	c,001H
	call	L102D
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L104D:
	ld	c,002H
	call	L102D
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L1054:
	ld	a,(X8043)
	ld	e,a
	add	a,a
	add	a,e
	add	a,c
	ld	d,000H
	ld	e,a
	ld	hl,02B10H
	add	hl,de
	ld	l,(hl)
	ld	h,000H
	ret
;
L1066:
	ld	c,000H
	call	L1054
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L106D:
	ld	c,001H
	call	L1054
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L1074:
	ld	c,002H
	call	L1054
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L107B:
	ld	a,l
	and	007H
	cp	005H
	jp	c,L1091
	ld	a,l
	and	070H
	cp	041H
	jp	c,L1091
	ld	hl,00080H
	jp	L1094
;
L1091:
	ld	hl,00000H
L1094:
	ret
;
L1095:
	call	L103F
	pop	hl
	call	L107B
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L109E:
	call	L1066
	pop	hl
	call	L107B
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L10A7:
	ld	a,(X804C)
	and	003H
	jp	z,L10B5
	ld	hl,000FFH
	jp	L10B8
;
L10B5:
	ld	hl,00000H
L10B8:
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L10BA:
	ld	de,00002H
	ld	hl,0802DH
	ld	b,(hl)
L10C1:
	ld	a,(X8036)
	cp	e
	jp	z,L10DA
	jp	nc,L10DA
	ld	hl,0802DH
	add	hl,de
	dec	hl
	ld	a,(hl)
	cp	b
	jp	nc,L10D6
	ld	b,a
L10D6:
	inc	de
	jp	L10C1
;
L10DA:
	ld	h,000H
	ld	l,b
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L10DF:
	ld	de,00004H
L10E2:
	push	de
	push	de
	ld	hl,00000H
	push	hl
	call	L02E0
	pop	hl
	push	hl
	ld	de,00004H
	or	a
	sbc	hl,de
	ld	de,X8051
	add	hl,de
	ld	(hl),000H
	pop	de
	ld	hl,0802DH
	add	hl,de
	ld	(hl),000H
	inc	de
	ld	a,e
	cp	008H
	jp	nz,L10E2
	ld	a,00FH
	ld	(X8055),a
	ld	(X8056),a
	ld	(X8057),a
	ret
;
L1113:
	ld	a,(X804D)
	cp	070H
	jp	nz,L1120
	ld	c,070H
	jp	L1135
;
L1120:
	ld	a,(X8046)
	and	003H
	jp	z,L1131
	ld	a,(X804D)
	add	a,090H
	ld	c,a
	jp	L1135
;
L1131:
	ld	a,(X804D)
	ld	c,a
L1135:
	push	bc
	call	L104D
	pop	hl
	pop	bc
	ld	a,l
	or	c
	ld	c,a
	ld	b,000H
	ld	hl,00010H
	push	hl
	push	bc
	call	L02E0
	ret
;
L1149:
	ld	a,(X804E)
	cp	070H
	jp	nz,L1156
	ld	c,070H
	jp	L116D
;
L1156:
	ld	a,(X8046)
	and	003H
	jp	z,L1167
	ld	a,(X804E)
	add	a,010H
	ld	c,a
	jp	L116D
;
L1167:
	ld	a,(X804E)
	add	a,010H
	ld	c,a
L116D:
	push	bc
	call	L1074
	pop	hl
	pop	bc
	ld	a,l
	or	c
	ld	c,a
	ld	b,000H
	push	bc
	ld	hl,00011H
	push	hl
	push	bc
	call	L02E0
	pop	bc
	push	bc
	ld	hl,00012H
	push	hl
	push	bc
	call	L02E0
	pop	bc
	ld	hl,00013H
	push	hl
	push	bc
	call	L02E0
	ret
;
L1195:
	call	L103F
	pop	hl
	ld	h,000H
	ld	de,0000BH
	push	de
	push	hl
	call	L02E0
	call	L1046
	pop	hl
	ld	h,000H
	ld	de,00017H
	push	de
	push	hl
	call	L02E0
	call	L1113
	ld	hl,X8051
	bit	7,(hl)
	jp	z,L11D8
	call	L1095
	pop	hl
	ld	h,000H
	ld	de,00004H
	push	de
	push	hl
	call	L02E0
	ld	hl,X8051
	ld	l,(hl)
	ld	h,000H
	ld	de,00004H
	push	de
	push	hl
	call	L02E0
L11D8:
	ret
;
L11D9:
	call	L1066
	pop	hl
	ld	h,000H
	ld	de,0000CH
	push	de
	push	hl
	call	L02E0
	call	L106D
	pop	hl
	ld	h,000H
	ld	de,00018H
	push	de
	push	hl
	call	L02E0
	call	L1149
	ld	hl,X8051
	ld	de,00001H
	add	hl,de
	bit	7,(hl)
	jp	z,L1224
	call	L109E
	pop	hl
	ld	h,000H
	ld	de,00005H
	push	de
	push	hl
	call	L02E0
	ld	hl,X8051
	ld	de,00001H
	add	hl,de
	ld	l,(hl)
	ld	h,000H
	ld	de,00005H
	push	de
	push	hl
	call	L02E0
L1224:
	ld	hl,X8051
	ld	de,00002H
	add	hl,de
	bit	7,(hl)
	jp	z,L1250
	call	L109E
	pop	hl
	ld	h,000H
	ld	de,00006H
	push	de
	push	hl
	call	L02E0
	ld	hl,X8051
	ld	de,00002H
	add	hl,de
	ld	l,(hl)
	ld	h,000H
	ld	de,00006H
	push	de
	push	hl
	call	L02E0
L1250:
	ld	hl,X8051
	ld	de,00003H
	add	hl,de
	bit	7,(hl)
	jp	z,L127C
	call	L109E
	pop	hl
	ld	h,000H
	ld	de,00007H
	push	de
	push	hl
	call	L02E0
	ld	hl,X8051
	ld	de,00003H
	add	hl,de
	ld	l,(hl)
	ld	h,000H
	ld	de,00007H
	push	de
	push	hl
	call	L02E0
L127C:
	ret
;
L127D:
	call	L1195
	call	L11D9
	ret
;
L1284:
	call	L10DF
	call	L127D
	call	L1113
	call	L1149
	ret
;
L1291:
	pop	hl
	ex	(sp),hl
	ld	b,l
	ld	hl,X804C
	ld	a,(hl)
	and	0CCH
	or	b
	ld	(hl),a
	ld	hl,X8046
	bit	3,(hl)
	jp	z,L12B2
	bit	0,(hl)
	jp	z,L12B2
	ld	(hl),011H
	xor	a
	ld	(X804A),a
	ld	(X804B),a
L12B2:
	ret
;
L12B3:
	ld	a,(X804C)
	bit	0,a
	jp	nz,L12C2
	ld	hl,00011H
	push	hl
	call	L1291
L12C2:
	ret
;
L12C3:
	ld	a,(X804C)
	bit	1,a
	jp	nz,L12D2
	ld	hl,00022H
	push	hl
	call	L1291
L12D2:
	ret
;
L12D3:
	ld	a,(X804C)
	bit	0,a
	jp	z,L12E1
	ld	hl,00010H
	jp	L12E9
;
L12E1:
	bit	1,a
	jp	z,L12ED
	ld	hl,00020H
L12E9:
	push	hl
	call	L1291
L12ED:
	ret
;
L12EE:
	ld	hl,08000H
	ld	de,0000CH
	add	hl,de
	bit	6,(hl)
	jp	z,L1300
	call	L12B3
	jp	L130E
;
L1300:
	bit	7,(hl)
	jp	z,L130B
	call	L12C3
	jp	L130E
;
L130B:
	call	L12D3
L130E:
	ret
;
L130F:
	ld	hl,00009H
	push	hl
	call	L047A
	pop	hl
	ld	h,000H
	ld	a,l
	and	01FH
	ld	l,a
	jp	z,L133A
	push	hl
	call	L0AAA
	pop	hl
	sla	l
	sla	l
	sla	l
	sla	l
	ld	a,l
	ld	(X804D),a
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	call	nz,L1113
L133A:
	ret
;
L133B:
	ld	hl,0000AH
	push	hl
	call	L047A
	pop	hl
	ld	h,000H
	ld	a,l
	and	01FH
	ld	l,a
	jp	z,L1366
	push	hl
	call	L0AAA
	pop	hl
	ld	a,l
	sla	a
	sla	a
	sla	a
	sla	a
	ld	(X804E),a
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	call	nz,L1149
L1366:
	ret
;
L1367:
	ld	hl,0000BH
	push	hl
	call	L047A
	pop	hl
	ld	a,l
	and	01FH
	ld	l,a
	ld	h,000H
	jp	z,L1381
	push	hl
	call	L0A97
	pop	hl
	ld	a,l
	ld	(X8042),a
L1381:
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	call	nz,L1195
	ret
;
L138B:
	ld	hl,0000CH
	push	hl
	call	L047A
	pop	hl
	ld	a,l
	and	01FH
	ld	l,a
	ld	h,000H
	jp	z,L13A5
	push	hl
	call	L0A97
	pop	hl
	ld	a,l
	ld	(X8043),a
L13A5:
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	call	nz,L11D9
	ret
;
L13AF:
	ld	hl,0000DH
	push	hl
	call	L047A
	pop	hl
	ld	a,l
	and	01FH
	ld	l,a
	ld	h,000H
	jp	z,L13C9
	push	hl
	call	L0A97
	pop	hl
	ld	a,l
	ld	(X804F),a
L13C9:
	ld	hl,X8024
	set	6,(hl)
	ret
;
L13CF:
	ld	hl,0000EH
	push	hl
	call	L047A
	pop	hl
	ld	a,l
	and	01FH
	ld	l,a
	ld	h,000H
	jp	z,L13E9
	push	hl
	call	L0A97
	pop	hl
	ld	a,l
	ld	(X8050),a
L13E9:
	ld	a,(X8050)
	cp	004H
	jp	nz,L13F7
	call	L19E5
	call	L19F2
L13F7:
	ld	hl,X8024
	set	4,(hl)
	ret
;
L13FD:
	ld	hl,0800FH
	ld	de,0000CH
	add	hl,de
	ld	a,(hl)
	and	0C0H
	call	nz,L12EE
	ld	hl,0800FH
	ld	de,00009H
	add	hl,de
	ld	a,(hl)
	and	01FH
	call	nz,L130F
	ld	hl,0800FH
	ld	de,0000AH
	add	hl,de
	ld	a,(hl)
	and	01FH
	call	nz,L133B
	ld	hl,0800FH
	ld	de,0000BH
	add	hl,de
	ld	a,(hl)
	and	01FH
	call	nz,L1367
	ld	hl,0800FH
	ld	de,0000CH
	add	hl,de
	ld	a,(hl)
	and	01FH
	call	nz,L138B
	ld	hl,0800FH
	ld	de,0000DH
	add	hl,de
	ld	a,(hl)
	and	01FH
	call	nz,L13AF
	ld	hl,0800FH
	ld	de,0000EH
	add	hl,de
	ld	a,(hl)
	and	01FH
	call	nz,L13CF
	ret
;
L1459:
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	jp	z,L14A5
L1462:
	ld	a,(X8036)
	cp	004H
	jp	z,L147A
	jp	c,L147A
	call	L10BA
	pop	hl
	ld	h,000H
	push	hl
	call	L05AE
	jp	L1462
;
L147A:
	ld	c,001H
L147C:
	ld	a,(X8036)
	cp	c
	jp	z,L14A5
	jp	c,L14A5
	ld	hl,0802DH
	ld	e,c
	ld	d,000H
	add	hl,de
	dec	hl
	ld	b,(hl)
	ld	a,b
	cp	019H
	jp	nc,L14A1
	push	bc
	ld	l,b
	ld	h,000H
	push	hl
	call	L05AE
	pop	bc
	jp	L147C
;
L14A1:
	inc	c
	jp	L147C
;
L14A5:
	call	L037B
	pop	hl
	ld	b,c
	ld	c,001H
L14AC:
	ld	a,(X8036)
	cp	c
	jp	z,L14CE
	jp	c,L14CE
	ld	hl,08025H
	ld	e,c
	ld	d,000H
	dec	de
	add	hl,de
	ld	(hl),c
	push	bc
	ld	l,c
	ld	h,000H
	push	hl
	ld	l,b
	push	hl
	call	L02E0
	pop	bc
	inc	c
	jp	L14AC
;
L14CE:
	ld	a,c
	cp	008H
	jp	nc,L14EE
	ld	hl,08025H
	ld	e,c
	ld	d,000H
	dec	de
	add	hl,de
	ld	(hl),c
	push	bc
	ld	l,c
	ld	h,000H
	push	hl
	ld	hl,00000H
	push	hl
	call	L02E0
	pop	bc
	inc	c
	jp	L14CE
;
L14EE:
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	jp	z,L1507
	ld	a,003H
	ld	(X8037),a
	ld	a,019H
	ld	(X8035),a
	call	L1284
	jp	L1511
;
L1507:
	ld	a,007H
	ld	(X8037),a
	ld	a,006H
	ld	(X8035),a
L1511:
	ld	hl,X8039
	res	0,(hl)
	call	L039A
	ld	a,0FFH
	ld	(X801E),a
	ret
;
L151F:
	ld	a,d
	cp	011H
	jp	z,L152E
	jp	c,L152E
	sub	012H
	ld	e,a
	jp	L1531
;
L152E:
	sub	006H
	ld	e,a
L1531:
	ld	a,(X805D)
	cp	00FH
	jp	nz,L1540
	ld	a,e
	ld	(X805D),a
	jp	L156A
;
L1540:
	ld	a,e
	cp	007H
	jp	z,L154B
	jp	c,L154B
	sub	007H
L154B:
	cp	001H
	jp	z,L155D
	cp	003H
	jp	z,L155D
	cp	006H
	jp	z,L155D
	jp	L1565
;
L155D:
	ld	hl,X805C
	set	4,(hl)
	jp	L156A
;
L1565:
	ld	hl,X805C
	set	5,(hl)
L156A:
	ret
;
L156B:
	ld	c,018H
	ld	b,005H
	ld	a,000H
	ld	(X805C),a
	ld	a,00FH
	ld	(X805D),a
L1579:
	ld	a,b
	cp	007H
	jp	nz,L1594
	ld	hl,08000H
	ld	e,b
	ld	d,000H
	add	hl,de
	ld	a,(hl)
	and	07FH
	ld	(X805A),a
	ld	a,007H
	ld	(X805B),a
	jp	L15A6
;
L1594:
	ld	hl,08000H
	ld	e,b
	ld	d,000H
	add	hl,de
	ld	a,(hl)
	and	03FH
	ld	(X805A),a
	ld	a,006H
	ld	(X805B),a
L15A6:
	ld	a,(X805A)
	or	a
	jp	z,L15C3
	bit	0,a
	jp	z,L15B6
	ld	d,c
	call	L151F
L15B6:
	ld	hl,X805A
	srl	(hl)
	dec	c
	ld	hl,X805B
	dec	(hl)
	jp	L15A6
;
L15C3:
	ld	a,c
	ld	hl,X805B
	sub	(hl)
	ld	c,a
	inc	b
	ld	a,c
	cp	006H
	jp	z,L1579
	jp	nc,L1579
	ld	a,(X805D)
	ld	b,a
	ld	a,(X805C)
	add	a,b
	ld	(X8055),a
	ret
;
L15DF:
	ld	a,(X805D)
	cp	000H
	jp	z,L15F4
	cp	004H
	jp	z,L160E
	cp	008H
	jp	z,L1646
	jp	L1658
;
L15F4:
	ld	a,(X805E)
	cp	091H
	jp	z,L1604
	cp	089H
	jp	z,L1609
	jp	L1658
;
L1604:
	ld	b,000H
	jp	L1658
;
L1609:
	ld	b,010H
	jp	L1658
;
L160E:
	ld	a,(X805E)
	cp	011H
	jp	z,L1632
	cp	091H
	jp	z,L1632
	cp	009H
	jp	z,L1637
	cp	089H
	jp	z,L1637
	cp	049H
	jp	z,L163C
	cp	0A1H
	jp	z,L1641
	jp	L1658
;
L1632:
	ld	b,020H
	jp	L1658
;
L1637:
	ld	b,030H
	jp	L1658
;
L163C:
	ld	b,050H
	jp	L1658
;
L1641:
	ld	b,060H
	jp	L1658
;
L1646:
	ld	a,(X805E)
	cp	091H
	jp	z,L1656
	cp	011H
	jp	z,L1656
	jp	L1658
;
L1656:
	ld	b,040H
L1658:
	ret
;
L1659:
	ld	a,d
	cp	011H
	jp	z,L1668
	jp	c,L1668
	sub	012H
	ld	e,a
	jp	L166B
;
L1668:
	sub	006H
	ld	e,a
L166B:
	cp	007H
	jp	z,L1685
	jp	c,L1685
	sub	008H
	ld	c,a
	ld	b,000H
	ld	hl,01697H
	add	hl,bc
	ld	a,(hl)
	ld	hl,X805D
	or	(hl)
	ld	(hl),a
	jp	L1692
;
L1685:
	ld	c,a
	ld	b,000H
	ld	hl,01697H
	add	hl,bc
	ld	a,(hl)
	ld	hl,X805E
	or	(hl)
	ld	(hl),a
L1692:
	ld	a,e
	ld	(X805C),a
	ret
;
	db	001H, 002H, 004H, 008H
	db	010H, 020H, 040H, 080H
;
L169F:
	ld	a,(X805D)
	ld	h,a
	ld	a,(X805E)
	ld	l,a
	srl	h
	rr	l
	jp	nc,L16B0
	set	3,h
L16B0:
	ld	a,h
	ld	(X805D),a
	ld	a,l
	ld	(X805E),a
	ret
;
L16B9:
	ld	a,b
	cp	0FFH
	jp	nz,L16D1
L16BF:
	call	L169F
	inc	c
	ld	a,c
	cp	00CH
	jp	nc,L16D1
	ld	hl,X805E
	bit	0,(hl)
	jp	z,L16BF
L16D1:
	ret
;
L16D2:
	ld	a,(X805D)
	ld	h,a
	ld	a,(X805E)
	ld	l,a
	ld	a,(X805C)
	ld	e,a
L16DE:
	ld	a,e
	cp	000H
	jp	z,L16ED
	push	hl
	call	L169F
	pop	hl
	dec	e
	jp	L16DE
;
L16ED:
	ld	a,(X805E)
	and	081H
	cp	081H
	jp	nz,L16FF
	ld	a,0FFH
	ld	(X8023),a
	jp	L1704
;
L16FF:
	ld	a,000H
	ld	(X8023),a
L1704:
	ld	a,h
	ld	(X805D),a
	ld	a,l
	ld	(X805E),a
	ret
;
L170D:
	ld	c,018H
	ld	b,005H
	ld	a,00FH
	ld	(X805C),a
	ld	a,000H
	ld	(X805E),a
	ld	(X805D),a
L171E:
	ld	a,b
	cp	007H
	jp	nz,L1739
	ld	hl,08000H
	ld	e,b
	ld	d,000H
	add	hl,de
	ld	a,(hl)
	and	07FH
	ld	(X805A),a
	ld	a,007H
	ld	(X805B),a
	jp	L174B
;
L1739:
	ld	hl,08000H
	ld	e,b
	ld	d,000H
	add	hl,de
	ld	a,(hl)
	and	03FH
	ld	(X805A),a
	ld	a,006H
	ld	(X805B),a
L174B:
	ld	a,(X805A)
	or	a
	jp	z,L176A
	bit	0,a
	jp	z,L175D
	ld	d,c
	push	bc
	call	L1659
	pop	bc
L175D:
	ld	hl,X805A
	srl	(hl)
	dec	c
	ld	hl,X805B
	dec	(hl)
	jp	L174B
;
L176A:
	ld	a,c
	ld	hl,X805B
	sub	(hl)
	ld	c,a
	inc	b
	ld	a,c
	cp	006H
	jp	nc,L171E
	push	bc
	call	L16D2
	pop	bc
	ld	c,000H
	ld	b,0FFH
	ld	hl,X805E
	bit	0,(hl)
	jp	nz,L178B
	call	L16B9
L178B:
	ld	a,b
	cp	0FFH
	jp	nz,L17A0
	ld	a,c
	cp	00CH
	jp	nc,L17A0
	call	L15DF
	call	L16B9
	jp	L178B
;
L17A0:
	ld	a,b
	cp	0FFH
	jp	z,L17B3
	ld	a,c
	add	a,b
	ld	(X8055),a
	ld	a,0FFH
	ld	(X8022),a
	jp	L17BE
;
L17B3:
	ld	a,(X805C)
	ld	(X8055),a
	ld	a,000H
	ld	(X8022),a
L17BE:
	ret
;
L17BF:
	ld	a,(X8055)
	cp	00FH
	jp	nz,L17CC
	ld	a,0FFH
	ld	(X8058),a
L17CC:
	ld	hl,X804C
	bit	0,(hl)
	jp	z,L17DF
	call	L156B
	ld	a,0FFH
	ld	(X8022),a
	jp	L17E2
;
L17DF:
	call	L170D
L17E2:
	ld	a,(X8055)
	cp	00FH
	jp	nz,L17EF
	ld	a,000H
	ld	(X8058),a
L17EF:
	ret
;
L17F0:
	call	L10A7
	pop	hl
	ld	a,l
	or	a
	jp	z,L1813
	call	L1284
	ld	a,(X8046)
	and	030H
	jp	z,L1809
	ld	a,0FFH
	ld	(X801E),a
L1809:
	ld	a,(X801F)
	or	a
	jp	z,L1813
	call	L17BF
L1813:
	ld	a,(X8046)
	and	003H
	jp	nz,L1828
	ld	a,010H
	ld	(XA01A),a    ; GE7 write drum triggers
	push	hl
	pop	hl
	ld	a,(X8044)
	ld	(XA01B),a    ; GE7 rhythm led
L1828:
	ret
;
L1829:
	pop	hl
	ex	(sp),hl
	ld	c,l
	ld	a,(X8056)
	and	00FH
	ld	b,a
	ld	a,c
	sub	b
	ld	(X8059),a
	ld	hl,0802DH
	ld	de,00003H
	add	hl,de
	ld	(hl),c
	ld	b,000H
	push	bc
	call	L02A2
	pop	hl
	ld	a,l
	or	080H
	ld	hl,X8051
	ld	(hl),a
	ret
;
L184E:
	ld	a,(X8056)
	and	00FH
	add	a,006H
	ld	l,a
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L185A:
	ld	ix,0802DH
	ld	de,00004H
	add	ix,de
	ld	a,(X8057)
	and	00FH
	add	a,006H
	ld	d,a
L186B:
	ld	a,d
	cp	019H
	jp	nc,L1877
	add	a,00CH
	ld	d,a
	jp	L186B
;
L1877:
	ld	(ix+000H),d
	ld	a,d
	add	a,b
	cp	025H
	jp	c,L1883
	sub	00CH
L1883:
	inc	ix
	ld	(ix+000H),a
	ld	a,d
	add	a,c
	cp	025H
	jp	c,L1891
	sub	00CH
L1891:
	inc	ix
	ld	(ix+000H),a
	ret
;
L1897:
	ld	a,(X8057)
	srl	a
	srl	a
	srl	a
	srl	a
	and	007H
	cp	000H
	jp	z,L18CA
	cp	001H
	jp	z,L18D1
	cp	002H
	jp	z,L18D8
	cp	003H
	jp	z,L18DF
	cp	004H
	jp	z,L18E6
	cp	005H
	jp	z,L18ED
	cp	006H
	jp	z,L18F4
	jp	L18FB
;
L18CA:
	ld	b,004H
	ld	c,007H
	jp	L18F8
;
L18D1:
	ld	b,003H
	ld	c,007H
	jp	L18F8
;
L18D8:
	ld	b,004H
	ld	c,00AH
	jp	L18F8
;
L18DF:
	ld	b,003H
	ld	c,00AH
	jp	L18F8
;
L18E6:
	ld	b,004H
	ld	c,00BH
	jp	L18F8
;
L18ED:
	ld	b,003H
	ld	c,00AH
	jp	L18F8
;
L18F4:
	ld	b,005H
	ld	c,00AH
L18F8:
	call	L185A
L18FB:
	ret
;
L18FC:
	ld	a,018H
	ld	(X8063),a
	ld	b,005H
	ld	ix,08000H
	ld	de,00005H
	add	ix,de
	ld	a,005H
	ld	(X8065),a
L1911:
	ld	a,b
	cp	007H
	jp	nz,L1925
	ld	a,(ix+000H)
	and	07FH
	ld	c,a
	ld	a,007H
	ld	(X8064),a
	jp	L1930
;
L1925:
	ld	a,(ix+000H)
	and	03FH
	ld	c,a
	ld	a,006H
	ld	(X8064),a
L1930:
	ld	a,c
	or	a
	jp	z,L1961
	ld	a,(X8065)
	cp	008H
	jp	nc,L1961
	bit	0,c
	jp	z,L1954
	ld	hl,0802DH
	ld	e,a
	ld	d,000H
	dec	de
	add	hl,de
	ld	a,(X8063)
	add	a,00CH
	ld	(hl),a
	ld	hl,X8065
	inc	(hl)
L1954:
	srl	c
	ld	hl,X8063
	dec	(hl)
	ld	hl,X8064
	dec	(hl)
	jp	L1930
;
L1961:
	ld	a,(X8063)
	ld	hl,X8064
	sub	(hl)
	ld	(X8063),a
	inc	b
	inc	ix
	ld	a,(X8063)
	cp	006H
	jp	c,L197E
	ld	a,(X8065)
	cp	008H
	jp	nz,L1911
L197E:
	ld	a,(X8065)
	cp	008H
	jp	nc,L1997
	ld	hl,0802DH
	ld	e,a
	ld	d,000H
	dec	de
	add	hl,de
	ld	(hl),000H
	ld	hl,X8065
	inc	(hl)
	jp	L197E
L1997:
	ret
;
L1998:
	ld	hl,X804C
	bit	0,(hl)
	push	af
	call	nz,L1897
	pop	af
	call	z,L18FC
	ret
;
L19A6:
	ld	de,00005H
L19A9:
	ld	hl,0802DH
	add	hl,de
	dec	hl
	ld	a,(hl)
	or	a
	jp	nz,L19C2
	ld	hl,X8051
	add	hl,de
	ld	bc,00004H
	and	a
	sbc	hl,bc
	ld	(hl),000H
	jp	L19DA
;
L19C2:
	push	de
	ld	l,a
	ld	h,000H
	push	hl
	call	L02A2
	pop	hl
	pop	de
	ld	a,l
	or	080H
	ld	hl,X8051
	add	hl,de
	ld	bc,00004H
	and	a
	sbc	hl,bc
	ld	(hl),a
L19DA:
	ld	a,e
	cp	007H
	jp	z,L19E4
	inc	e
	jp	L19A9
L19E4:
	ret
;
L19E5:
	ld	hl,X8051
	inc	hl
	res	7,(hl)
	inc	hl
	res	7,(hl)
	inc	hl
	res	7,(hl)
	ret
;
L19F2:
	ld	bc,00005H
	push	bc
	ld	hl,X8051
	ld	de,00001H
	add	hl,de
	ld	c,(hl)
	push	bc
	call	L02E0
	ld	bc,00006H
	push	bc
	ld	hl,X8051
	ld	de,00002H
	add	hl,de
	ld	c,(hl)
	push	bc
	call	L02E0
	ld	bc,00007H
	push	bc
	ld	hl,X8051
	ld	de,00003H
	add	hl,de
	ld	c,(hl)
	push	bc
	call	L02E0
	ret
;
L1A23:
	ld	hl,00004H
	push	hl
	ld	a,(X8051)
	ld	l,a
	push	hl
	call	L02E0
	call	L19F2
	ret
;
L1A33:
	ld	a,(X8056)
	ld	b,a
	ld	a,(X8055)
	cp	b
	jp	nz,L1A56
	ld	a,(X8020)
	or	a
	jp	nz,L1A56
	call	L0AEB
	pop	hl
	ld	a,l
	or	a
	jp	nz,L1A56
	ld	hl,X8024
	bit	4,(hl)
	jp	z,L1A91
L1A56:
	ld	a,(X8046)
	and	003H
	jp	nz,L1A6A
	ld	a,(X8055)
	ld	(X8056),a
	call	L184E
	call	L1829
L1A6A:
	ld	a,(X8055)
	ld	(X8057),a
	call	L1998
	call	L19A6
	ld	a,(X8046)
	and	003H
	jp	nz,L1A84
	call	L1A23
	jp	L1A91
;
L1A84:
	call	L0AEB
	pop	hl
	ld	a,l
	cp	000H
	jp	nz,L1A91
	call	L19F2
L1A91:
	ret
;
L1A92:
	ld	a,(X8046)
	and	003H
	jp	nz,L1AB6
	ld	hl,X8051
	bit	7,(hl)
	jp	nz,L1AA8
	inc	hl
	bit	7,(hl)
	jp	z,L1AC5
L1AA8:
	ld	hl,X8051
	res	7,(hl)
	call	L19E5
	call	L1A23
	jp	L1AC5
;
L1AB6:
	ld	hl,X8051
	inc	hl
	bit	7,(hl)
	jp	z,L1AC5
	call	L19E5
	call	L19F2
L1AC5:
	ret
;
L1AC6:
	ld	a,(X801F)
	cp	0FFH
	push	af
	call	z,L1A33
	pop	af
	call	nz,L1A92
	ret
;
L1AD4:
	pop	hl
	ex	(sp),hl
	ld	a,(X8047)
	cp	014H
	jp	nc,L1AFB
	cp	010H
	jp	nc,L1AEB
	cp	008H
	jp	nc,L1AF3
	jp	L1AFB
;
L1AEB:
	ld	b,002H
	sub	010H
	ld	c,a
	jp	L1AFE
;
L1AF3:
	ld	b,001H
	sub	008H
	ld	c,a
	jp	L1AFE
;
L1AFB:
	ld	b,000H
	ld	c,a
L1AFE:
	push	hl
	ld	ix,05E1BH
	ld	a,(X8049)
	ld	e,a
	ld	d,000H
	ld	hl,01B41H
	add	hl,de
	ld	e,(hl)
	ld	d,000H
	add	ix,de
	ld	e,b
	ld	d,000H
	ld	hl,01B44H
	add	hl,de
	ld	e,(hl)
	ld	d,000H
	add	ix,de
	pop	hl
	ld	e,l
	ld	d,000H
	add	ix,de
	ld	d,(ix+000H)
L1B27:
	ld	a,c
	cp	000H
	jp	z,L1B33
	sla	d
	dec	c
	jp	L1B27
;
L1B33:
	ld	b,000H
	bit	7,d
	jp	z,L1B3C
	ld	b,001H
L1B3C:
	ld	l,b
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
	db	000H, 060H, 0C0H, 000H
	db	020H, 040H
;
L1B47:
	pop	hl
	ex	(sp),hl
	ld	a,l
	ld	(X8066),a
	ld	hl,X804B
	bit	0,(hl)
	jp	z,L1B5A
	ld	l,0FFH
	jp	L1C2F
;
L1B5A:
	ld	a,(X8066)
	and	07FH
	ld	(X8067),a
	ld	hl,X804A
	bit	0,(hl)
	jp	z,L1B7C
	ld	a,(X8067)
	ld	l,a
	ld	h,000H
	push	hl
	call	L1AD4
	pop	hl
	ld	a,l
	ld	(X8068),a
	jp	L1C21
;
L1B7C:
	ld	a,(X8047)
	cp	014H
	jp	nc,L1BC4
	cp	010H
	jp	c,L1B94
	sub	010H
	ld	d,a
	ld	a,004H
	ld	(X8068),a
	jp	L1BCA
;
L1B94:
	cp	00CH
	jp	c,L1BA4
	sub	00CH
	ld	d,a
	ld	a,003H
	ld	(X8068),a
	jp	L1BCA
;
L1BA4:
	cp	008H
	jp	c,L1BB4
	sub	008H
	ld	d,a
	ld	a,002H
	ld	(X8068),a
	jp	L1BCA
;
L1BB4:
	cp	004H
	jp	c,L1BC4
	sub	004H
	ld	d,a
	ld	a,001H
	ld	(X8068),a
	jp	L1BCA
;
L1BC4:
	ld	d,a
	ld	a,000H
	ld	(X8068),a
L1BCA:
	ld	ix,04DDBH
	ld	a,(X8050)
	ld	c,a
	ld	b,000H
	ld	hl,01C33H
	add	hl,bc
	ld	c,(hl)
	add	ix,bc
	ld	a,(X8068)
	ld	c,a
	ld	hl,01C35H
	add	hl,bc
	ld	c,(hl)
	add	ix,bc
	ld	a,(X8067)
	ld	c,a
	add	ix,bc
	ld	e,(ix+000H)
L1BEF:
	ld	a,d
	cp	000H
	jp	z,L1BFD
	sla	e
	sla	e
	dec	d
	jp	L1BEF
;
L1BFD:
	ld	a,000H
	ld	(X8068),a
	ld	hl,X8066
	bit	7,(hl)
	jp	z,L1C17
	bit	6,e
	jp	z,L1C21
	ld	a,001H
	ld	(X8068),a
	jp	L1C21
;
L1C17:
	bit	7,e
	jp	z,L1C21
	ld	a,001H
	ld	(X8068),a
L1C21:
	ld	a,(X8068)
	or	a
	jp	nz,L1C2D
	ld	l,000H
	jp	L1C2F
;
L1C2D:
	ld	l,0FFH
L1C2F:
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
	db	000H, 0A0H, 000H, 020H
	db	040H, 060H, 080H
;
L1C3A:
	ld	hl,X803D
	bit	0,(hl)
	jp	z,L1C56
	ld	a,(X8045)
	cp	001H
	jp	nz,L1C5B
	bit	1,(hl)
	jp	z,L1C56
	ld	a,(X8058)
	or	a
	jp	z,L1C5B
L1C56:
	ld	l,0FFH
	jp	L1C5D
;
L1C5B:
	ld	l,000H
L1C5D:
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L1C61:
	pop	hl
	ex	(sp),hl
	ld	a,l
	cp	000H
	jp	z,L1C73
	cp	0FFH
	jp	z,L1C73
	ld	l,0FFH
	jp	L1C75
;
L1C73:
	ld	l,000H
L1C75:
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L1C79:
	ld	a,d
	or	a
	jp	z,L1C85
	cp	h
	jp	z,L1C89
	jp	c,L1C89
L1C85:
	ld	a,b
	sub	010H
	ld	b,a
L1C89:
	ld	d,h
	ret
;
L1C8B:
	pop	hl
	ex	(sp),hl
	ld	b,l
	ld	a,(X8057)
	srl	a
	srl	a
	srl	a
	srl	a
	and	007H
	ld	c,a
	ld	a,b
	and	00FH
	ld	d,a
	ld	a,b
	and	0C0H
	cp	040H
	jp	z,L1CB0
	cp	080H
	jp	z,L1CCB
	jp	L1CDB
;
L1CB0:
	ld	a,c
	cp	002H
	jp	nz,L1CBE
	ld	h,00AH
	call	L1C79
	jp	L1CDB
;
L1CBE:
	cp	004H
	jp	nz,L1CDB
	ld	h,00BH
	call	L1C79
	jp	L1CDB
;
L1CCB:
	ld	a,c
	cp	002H
	jp	z,L1CD6
	cp	003H
	jp	nz,L1CDB
L1CD6:
	ld	h,00AH
	call	L1C79
L1CDB:
	ld	ix,02BC7H
	push	bc
	ld	b,000H
	ld	hl,01D26H
	add	hl,bc
	ld	c,(hl)
	ld	b,000H
	add	ix,bc
	ld	c,d
	add	ix,bc
	pop	bc
	ld	c,(ix+000H)
	ld	a,b
	and	030H
	srl	a
	srl	a
	srl	a
	srl	a
	and	00FH
	ld	e,a
L1D00:
	ld	a,e
	cp	000H
	jp	z,L1D0E
	ld	a,c
	add	a,00CH
	ld	c,a
	dec	e
	jp	L1D00
;
L1D0E:
	ld	a,(X8057)
	and	00FH
	cp	00AH
	jp	nc,L1D1E
	ld	a,c
	add	a,012H
	jp	L1D21
;
L1D1E:
	ld	a,c
	add	a,006H
L1D21:
	ld	l,a
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
	db	000H, 00CH, 018H, 024H
	db	030H, 03CH, 048H
;
L1D2D:
	call	L109E
	pop	hl
	ld	a,l
	or	a
	jp	nz,L1E1C
	ld	a,(X8024)
	and	030H
	jp	z,L1E1C
	ld	a,(X806F)
	cp	0FFH
	jp	nz,L1DAA
	ld	a,(X806E)
	ld	(X8070),a
	ld	ix,04F1BH
	ld	a,(X806B)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,01ECEH
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X806C)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,01ED2H
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X806D)
	ld	e,a
	ld	d,000H
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	add	ix,de
	ld	a,(X8070)
	ld	e,a
	ld	d,000H
	add	ix,de
L1D92:
	ld	hl,X8070
	dec	(hl)
	dec	ix
	ld	a,(ix+000H)
	ld	(X806F),a
	cp	0FFH
	jp	nz,L1DAA
	ld	a,(X8070)
	or	a
	jp	nz,L1D92
L1DAA:
	ld	a,(X806F)
	cp	0FFH
	jp	nz,L1E1C
	call	L0AC3
	pop	hl
	ld	a,l
	srl	a
	add	a,001H
	ld	(X8070),a
	ld	ix,04F1BH
	ld	a,(X806B)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,01ECEH
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X806C)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,01ED2H
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X8047)
	ld	e,a
	ld	d,000H
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	add	ix,de
	ld	a,(X8070)
	ld	e,a
	ld	d,000H
	add	ix,de
L1E04:
	ld	hl,X8070
	dec	(hl)
	dec	ix
	ld	a,(ix+000H)
	ld	(X806F),a
	cp	0FFH
	jp	nz,L1E1C
	ld	a,(X8070)
	or	a
	jp	nz,L1E04
L1E1C:
	ret
;
L1E1D:
	pop	hl
	pop	de
	ex	(sp),hl
	ld	a,l
	ld	(X8069),a
	ld	a,e
	ld	(X806A),a
	ld	a,(X8050)
	sub	002H
	ld	(X806B),a
	ld	a,(X806A)
	sub	001H
	ld	(X806C),a
	ld	hl,X8069
	bit	7,(hl)
	jp	z,L1E4B
	ld	a,(X8047)
	add	a,014H
	ld	(X806D),a
	jp	L1E51
;
L1E4B:
	ld	a,(X8047)
	ld	(X806D),a
L1E51:
	ld	a,(X8069)
	and	07FH
	srl	a
	ld	(X806E),a
	ld	ix,04F1BH
	ld	a,(X806B)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,01ECEH
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X806C)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,01ED2H
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X806D)
	ld	e,a
	ld	d,000H
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	add	ix,de
	ld	a,(X806E)
	ld	e,a
	ld	d,000H
	add	ix,de
	ld	a,(ix+000H)
	ld	(X806F),a
	call	L1D2D
	ld	a,(X806F)
	ld	l,a
	ld	h,000H
	push	hl
	call	L1C61
	pop	af
	jp	nc,L1EC6
	ld	a,(X806F)
	ld	l,a
	ld	h,000H
	push	hl
	call	L1C8B
	pop	hl
	jp	L1ECC
;
L1EC6:
	ld	a,(X806F)
	ld	l,a
	ld	h,000H
L1ECC:
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
	db	000H, 000H, 080H, 007H
	db	000H, 000H, 080H, 002H
	db	000H, 005H
;
L1ED8:
	pop	hl
	pop	bc
	ex	(sp),hl
	ld	b,c
	ld	e,l
	ld	hl,X804B
	bit	0,(hl)
	jp	z,L1EEA
	ld	l,000H
	jp	L1F3A
;
L1EEA:
	bit	0,e
	jp	z,L1F2E
	push	bc
	push	de
	call	L0AC3
	pop	hl
	pop	de
	pop	bc
	ld	a,l
	cp	e
	jp	nz,L1F0B
	bit	7,e
	jp	z,L1F06
	ld	c,000H
	jp	L1F0F
;
L1F06:
	ld	c,080H
	jp	L1F0F
;
L1F0B:
	ld	a,e
	add	a,001H
	ld	c,a
L1F0F:
	push	bc
	push	de
	ld	l,c
	ld	h,000H
	push	hl
	ld	l,b
	push	hl
	call	L1E1D
	pop	hl
	pop	de
	pop	bc
	ld	c,l
	ld	a,c
	cp	0FFH
	jp	z,L1F29
	ld	c,000H
	jp	L1F39
;
L1F29:
	ld	c,0FFH
	jp	L1F39
;
L1F2E:
	ld	l,e
	ld	h,000H
	push	hl
	ld	l,b
	push	hl
	call	L1E1D
	pop	hl
	ld	c,l
L1F39:
	ld	l,c
L1F3A:
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L1F3E:
	pop	hl
	pop	bc
	ex	(sp),hl
	ld	b,c
	ld	c,l
	ld	a,(X8022)
	cp	0FFH
	jp	nz,L1F69
	ld	a,(X8057)
	and	00FH
	add	a,b
	push	bc
	ld	l,a
	ld	h,000H
	push	hl
	call	L02A2
	pop	hl
	pop	bc
	ld	a,l
	or	080H
	ld	hl,X8051
	ld	e,c
	ld	d,000H
	add	hl,de
	ld	(hl),a
	jp	L1F8D
;
L1F69:
	ld	hl,0802DH
	ld	a,c
	add	a,004H
	ld	e,a
	ld	d,000H
	dec	de
	add	hl,de
	ld	a,(hl)
	cp	000H
	jp	z,L1F8D
	ld	l,a
	ld	h,000H
	push	hl
	call	L02A2
	pop	hl
	ld	a,l
	or	080H
	ld	hl,X8051
	ld	e,c
	ld	d,000H
	add	hl,de
	ld	(hl),a
L1F8D:
	ret
;
L1F8E:
	pop	hl
	ex	(sp),hl
	ld	c,l
	ld	a,(X8021)
	cp	0FFH
	jp	nz,L1FCE
	push	bc
	call	L1C3A
	pop	hl
	pop	bc
	ld	a,l
	cp	0FFH
	jp	nz,L1FCE
	push	bc
	ld	a,(X803D)
	ld	l,a
	ld	h,000H
	push	hl
	ld	l,c
	push	hl
	call	L1ED8
	pop	hl
	pop	bc
	ld	b,l
	push	bc
	ld	l,b
	ld	h,000H
	push	hl
	call	L1C61
	pop	hl
	pop	bc
	ld	a,l
	cp	0FFH
	jp	nz,L1FCE
	ld	l,c
	ld	h,000H
	push	hl
	ld	l,b
	push	hl
	call	L1F3E
L1FCE:
	ret
;
L1FCF:
	pop	hl
	pop	de
	ex	(sp),hl
	ld	c,l
	ld	b,e
	push	bc
	ld	l,b
	ld	h,000H
	push	hl
	call	L1F8E
	pop	bc
	push	bc
	call	L0AEB
	pop	hl
	pop	bc
	ld	a,l
	cp	0FFH
	jp	z,L1FF8
	ld	a,(X8024)
	and	033H
	jp	nz,L1FF8
	ld	a,(X8021)
	or	a
	jp	z,L2024
L1FF8:
	push	bc
	ld	l,c
	ld	h,000H
	push	hl
	ld	l,b
	push	hl
	call	L1ED8
	pop	hl
	pop	bc
	ld	c,l
	ld	a,c
	or	a
	jp	nz,L2016
	ld	hl,X8051
	ld	e,b
	ld	d,000H
	add	hl,de
	res	7,(hl)
	jp	L2024
;
L2016:
	cp	0FFH
	jp	z,L2024
	ld	l,b
	ld	h,000H
	push	hl
	ld	l,c
	push	hl
	call	L1F3E
L2024:
	ret
;
L2025:
	pop	hl
	ex	(sp),hl
	ld	c,l
	push	bc
	ld	l,c
	ld	h,000H
	push	hl
	ld	l,001H
	push	hl
	call	L1FCF
	pop	bc
	push	bc
	ld	l,c
	ld	h,000H
	push	hl
	ld	l,002H
	push	hl
	call	L1FCF
	pop	bc
	ld	l,c
	ld	h,000H
	push	hl
	ld	l,003H
	push	hl
	call	L1FCF
	ret
;
L204B:
	ld	a,(X8050)
	cp	002H
	jp	c,L2060
	ld	hl,X804A
	bit	0,(hl)
	jp	nz,L2060
	ld	l,0FFH
	jp	L2062
;
L2060:
	ld	l,000H
L2062:
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L2066:
	ld	hl,00000H
	push	hl
	call	L244C
	pop	hl
	ld	c,l
	ld	a,c
	cp	0FFH
	jp	z,L208F
	cp	000H
	jp	nz,L2082
	ld	hl,X8051
	res	7,(hl)
	jp	L208F
;
L2082:
	ld	a,(X8056)
	and	00FH
	add	a,c
	ld	l,a
	ld	h,000H
	push	hl
	call	L1829
L208F:
	ret
;
L2090:
	pop	hl
	ex	(sp),hl
	ld	a,l
	ld	(X8071),a
	and	00FH
	ld	b,a
	ld	a,(X8056)
	srl	a
	srl	a
	srl	a
	srl	a
	and	007H
	ld	c,a
	cp	002H
	jp	nz,L20B8
	ld	a,(X8071)
	and	0C0H
	cp	040H
	jp	nz,L20B8
	ld	b,00AH
L20B8:
	ld	ix,02B73H
	ld	hl,020D7H
	ld	e,c
	ld	d,000H
	add	hl,de
	ld	e,(hl)
	add	ix,de
	ld	e,b
	add	ix,de
	ld	b,(ix+000H)
	ld	a,(X8071)
	and	030H
	or	b
	ld	l,a
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
	db	000H, 00CH, 018H, 024H
	db	030H, 03CH, 048H
;
L20DE:
	pop	hl
	ex	(sp),hl
	ld	c,l
	ld	ix,04A1BH
	ld	a,(X8049)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,02167H
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X8047)
	ld	e,a
	ld	d,000H
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	add	ix,de
	ld	e,c
	ld	d,000H
	add	ix,de
	ld	b,(ix+000H)
	ld	a,b
	cp	0FFH
	jp	nz,L2147
	push	ix
	push	bc
	call	L1095
	pop	hl
	pop	bc
	pop	ix
	ld	a,l
	cp	000H
	jp	nz,L2147
	ld	a,(X8024)
	and	062H
	cp	000H
	jp	z,L2147
L2136:
	dec	c
	dec	ix
	ld	b,(ix+000H)
	ld	a,b
	cp	0FFH
	jp	nz,L2147
	ld	a,c
	or	a
	jp	nz,L2136
L2147:
	push	bc
	ld	l,b
	ld	h,000H
	push	hl
	call	L1C61
	pop	hl
	pop	bc
	ld	a,l
	cp	0FFH
	jp	nz,L2162
	ld	l,b
	ld	h,000H
	push	hl
	call	L2090
	pop	hl
	jp	L2163
;
L2162:
	ld	l,b
L2163:
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
	db	000H, 000H, 040H, 001H
	db	080H, 002H
;
L216D:
	pop	hl
	ex	(sp),hl
	ld	c,l
	ld	ix,0375BH
	ld	a,(X804F)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,021F4H
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X8047)
	ld	e,a
	ld	d,000H
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	add	ix,de
	ld	e,c
	ld	d,000H
	add	ix,de
	ld	b,(ix+000H)
	ld	a,b
	cp	0FFH
	jp	nz,L21D4
	push	bc
	push	ix
	call	L1095
	pop	hl
	pop	ix
	pop	bc
	ld	a,l
	cp	000H
	jp	nz,L21D4
	ld	a,(X8024)
	and	060H
	jp	z,L21D4
L21C3:
	dec	c
	dec	ix
	ld	b,(ix+000H)
	ld	a,b
	cp	0FFH
	jp	nz,L21D4
	ld	a,c
	or	a
	jp	nz,L21C3
L21D4:
	push	bc
	ld	l,b
	ld	h,000H
	push	hl
	call	L1C61
	pop	hl
	pop	bc
	ld	a,l
	cp	0FFH
	jp	nz,L21EF
	ld	l,b
	ld	h,000H
	push	hl
	call	L2090
	pop	hl
	jp	L21F0
;
L21EF:
	ld	l,b
L21F0:
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
	db	000H, 000H, 080H, 002H
	db	000H, 005H, 080H, 007H
	db	000H, 00AH
;
L21FE:
	pop	hl
	ex	(sp),hl
	ld	c,l
	ld	ix,043DBH
	ld	a,(X804F)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,0226AH
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X8047)
	ld	e,a
	ld	d,000H
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	add	ix,de
	ld	e,c
	ld	d,000H
	add	ix,de
	ld	b,(ix+000H)
	ld	a,b
	cp	0FFH
	jp	nz,L2265
	push	bc
	push	ix
	call	L1095
	pop	hl
	pop	ix
	pop	bc
	ld	a,l
	cp	000H
	jp	nz,L2265
	ld	a,(X8024)
	and	060H
	jp	z,L2265
L2254:
	dec	c
	dec	ix
	ld	b,(ix+000H)
	ld	a,b
	cp	0FFH
	jp	nz,L2265
	ld	a,c
	or	a
	jp	nz,L2254
L2265:
	ld	l,b
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
	db	000H, 000H, 040H, 001H
	db	080H, 002H, 0C0H, 003H
	db	000H, 005H
;
L2274:
	pop	hl
	ex	(sp),hl
	ld	c,l
	ld	ix,0375BH
	ld	a,(X804F)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,021F4H
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X8047)
	add	a,014H
	ld	e,a
	ld	d,000H
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	add	ix,de
	ld	e,c
	ld	d,000H
	add	ix,de
	ld	b,(ix+000H)
	ld	a,b
	cp	0FFH
	jp	nz,L22DD
	push	bc
	push	ix
	call	L1095
	pop	hl
	pop	ix
	pop	bc
	ld	a,l
	cp	000H
	jp	nz,L22DD
	ld	a,(X8024)
	and	060H
	jp	z,L22DD
L22CC:
	dec	c
	dec	ix
	ld	b,(ix+000H)
	ld	a,b
	cp	0FFH
	jp	nz,L22DD
	ld	a,c
	or	a
	jp	nz,L22CC
L22DD:
	ld	l,b
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L22E2:
	pop	hl
	ex	(sp),hl
	ld	a,l
	ld	(X8072),a
	ld	a,(X8056)
	srl	a
	srl	a
	srl	a
	srl	a
	and	007H
	ld	(X8073),a
	cp	002H
	jp	nz,L230F
	ld	a,(X8072)
	ld	l,a
	ld	h,000H
	push	hl
	call	L21FE
	pop	hl
	ld	a,l
	ld	(X8074),a
	jp	L231E
;
L230F:
	ld	a,(X8072)
	ld	l,a
	ld	h,000H
	push	hl
	call	L2274
	pop	hl
	ld	a,l
	ld	(X8074),a
L231E:
	ld	a,(X8074)
	cp	0FFH
	jp	nz,L238D
	call	L1095
	pop	hl
	ld	a,l
	or	a
	jp	nz,L238D
	ld	a,(X8024)
	and	060H
	jp	z,L238D
	call	L0AC3
	pop	hl
	ld	a,l
	srl	a
	inc	a
	ld	(X8075),a
	ld	ix,0375BH
	ld	a,(X804F)
	sla	a
	ld	e,a
	ld	d,000H
	ld	hl,021F4H
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	add	ix,de
	ld	a,(X8047)
	ld	e,a
	ld	d,000H
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	sla	e
	rl	d
	add	ix,de
	ld	a,(X8075)
	ld	e,a
	ld	d,000H
	add	ix,de
	ld	hl,X8075
L237A:
	dec	(hl)
	dec	ix
	ld	a,(ix+000H)
	ld	(X8074),a
	cp	0FFH
	jp	nz,L238D
	ld	a,(hl)
	or	a
	jp	nz,L237A
L238D:
	ld	a,(X8074)
	ld	l,a
	ld	h,000H
	push	hl
	call	L1C61
	pop	hl
	ld	a,l
	cp	0FFH
	jp	nz,L23AC
	ld	a,(X8074)
	ld	l,a
	ld	h,000H
	push	hl
	call	L2090
	pop	hl
	jp	L23B0
;
L23AC:
	ld	a,(X8074)
	ld	l,a
L23B0:
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L23B4:
	pop	hl
	ex	(sp),hl
	ld	e,l
	ld	a,e
	and	07FH
	srl	a
	ld	b,a
	ld	hl,X804A
	bit	0,(hl)
	jp	z,L23D5
	push	bc
	push	de
	ld	l,b
	ld	h,000H
	push	hl
	call	L20DE
	pop	hl
	pop	de
	pop	bc
	ld	c,l
	jp	L23F7
;
L23D5:
	bit	7,e
	jp	z,L23EA
	push	bc
	push	de
	ld	l,b
	ld	h,000H
	push	hl
	call	L22E2
	pop	hl
	pop	de
	pop	bc
	ld	c,l
	jp	L23F7
;
L23EA:
	push	bc
	push	de
	ld	l,b
	ld	h,000H
	push	hl
	call	L216D
	pop	hl
	pop	de
	pop	bc
	ld	c,l
L23F7:
	push	bc
	push	de
	ld	l,c
	ld	h,000H
	push	hl
	call	L1C61
	pop	hl
	pop	de
	pop	bc
	ld	a,l
	cp	0FFH
	jp	nz,L2447
	ld	a,c
	and	00FH
	ld	b,a
	ld	a,(X8022)
	cp	0FFH
	jp	z,L2423
	ld	a,(X8023)
	cp	0FFH
	jp	nz,L2445
	ld	a,b
	cp	007H
	jp	nz,L2445
L2423:
	ld	a,c
	and	030H
	srl	a
	srl	a
	srl	a
	srl	a
	and	00FH
	ld	d,a
L2431:
	ld	a,d
	or	a
	jp	z,L243E
	ld	a,b
	add	a,00CH
	ld	b,a
	dec	d
	jp	L2431
;
L243E:
	ld	a,b
	sub	006H
	ld	c,a
	jp	L2447
;
L2445:
	ld	c,006H
L2447:
	ld	l,c
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L244C:
	pop	hl
	ex	(sp),hl
	ld	c,l
	ld	hl,X804B
	bit	0,(hl)
	jp	z,L2467
	ld	a,c
	and	07FH
	jp	z,L2462
	ld	l,0FFH
	jp	L24B0
;
L2462:
	ld	l,006H
	jp	L24B0
;
L2467:
	bit	0,c
	jp	z,L24A4
	push	bc
	call	L0AC3
	pop	hl
	pop	bc
	ld	a,c
	cp	l
	jp	nz,L2486
	bit	7,c
	jp	z,L2481
	ld	b,000H
	jp	L2489
;
L2481:
	ld	b,080H
	jp	L2489
;
L2486:
	ld	a,c
	inc	a
	ld	b,a
L2489:
	push	bc
	ld	l,b
	ld	h,000H
	push	hl
	call	L23B4
	pop	hl
	pop	bc
	ld	b,l
	ld	a,b
	cp	0FFH
	jp	z,L249F
	ld	b,000H
	jp	L24AF
;
L249F:
	ld	b,0FFH
	jp	L24AF
;
L24A4:
	push	bc
	ld	l,c
	ld	h,000H
	push	hl
	call	L23B4
	pop	hl
	pop	bc
	ld	b,l
L24AF:
	ld	l,b
L24B0:
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L24B4:
	ld	a,(X8021)
	cp	0FFH
	jp	nz,L2523
	call	L1C3A
	pop	af
	jp	nc,L2523
	ld	a,(X803D)
	ld	l,a
	ld	h,000H
	push	hl
	call	L244C
	pop	hl
	ld	c,l
	push	bc
	ld	l,c
	ld	h,000H
	push	hl
	call	L1C61
	pop	af
	pop	bc
	jp	nc,L2523
	ld	hl,X8056
	bit	7,(hl)
	jp	z,L24FD
	ld	a,012H
	cp	c
	jp	nz,L24F5
	call	L184E
	pop	hl
	ld	a,l
	add	a,00CH
	ld	c,a
	jp	L2504
;
L24F5:
	call	L184E
	pop	hl
	ld	c,l
	jp	L2504
;
L24FD:
	ld	a,(X8056)
	and	00FH
	add	a,c
	ld	c,a
L2504:
	ld	hl,0802DH
	ld	de,00003H
	add	hl,de
	ld	a,(hl)
	cp	c
	jp	z,L2523
	ld	l,c
	ld	h,000H
	push	hl
	call	L1829
	ld	hl,00004H
	push	hl
	ld	a,(X8051)
	ld	l,a
	push	hl
	call	L02E0
L2523:
	ret
;
L2524:
	ld	a,(X8056)
	and	00FH
	ld	b,a
	ld	a,(X8055)
	and	00FH
	cp	b
	jp	z,L253E
	ld	a,(X8055)
	or	080H
	ld	(X8056),a
	jp	L254B
;
L253E:
	ld	a,(X8056)
	and	080H
	ld	b,a
	ld	a,(X8055)
	or	b
	ld	(X8056),a
L254B:
	call	L24B4
	ld	a,(X8024)
	and	063H
	jp	nz,L255D
	ld	a,(X8021)
	or	a
	jp	z,L25D6
L255D:
	ld	a,(X803E)
	ld	l,a
	ld	h,000H
	push	hl
	call	L244C
	pop	hl
	ld	c,l
	ld	a,c
	or	a
	jp	nz,L2576
	ld	hl,X8051
	res	7,(hl)
	jp	L2607
;
L2576:
	ld	hl,X8056
	bit	7,(hl)
	jp	z,L25C0
	push	bc
	call	L1095
	pop	hl
	pop	bc
	ld	a,l
	cp	000H
	jp	z,L2590
	ld	a,c
	cp	0FFH
	jp	z,L2607
L2590:
	ld	a,012H
	cp	c
	jp	z,L25A4
	ld	a,(X8059)
	cp	012H
	jp	nz,L25B2
	ld	a,0FFH
	cp	c
	jp	nz,L25B2
L25A4:
	call	L184E
	pop	hl
	ld	a,l
	add	a,00CH
	ld	l,a
	ld	h,000H
	push	hl
	jp	L25B5
;
L25B2:
	call	L184E
L25B5:
	call	L1829
	ld	hl,X8056
	res	7,(hl)
	jp	L2607
;
L25C0:
	ld	a,c
	cp	0FFH
	jp	z,L2607
	ld	a,(X8056)
	and	00FH
	add	a,c
	ld	l,a
	ld	h,000H
	push	hl
	call	L1829
	jp	L2607
;
L25D6:
	ld	hl,X8051
	bit	7,(hl)
	jp	z,L2607
	ld	hl,X8056
	bit	7,(hl)
	jp	z,L2607
	ld	a,(X8059)
	cp	012H
	jp	nz,L25FC
	call	L184E
	pop	hl
	ld	a,l
	add	a,00CH
	ld	l,a
	ld	h,000H
	push	hl
	jp	L25FF
;
L25FC:
	call	L184E
L25FF:
	call	L1829
	ld	hl,X8056
	res	7,(hl)
L2607:
	ret
;
L2608:
	ld	a,(X8021)
	cp	0FFH
	jp	nz,L2639
	call	L1C3A
	pop	af
	jp	nc,L2639
	ld	a,(X803F)
	ld	a,l
	ld	h,000H
	push	hl
	call	L1B47
	pop	af
	jp	c,L2639
	ld	a,(X803D)
	ld	l,a
	ld	h,000H
	push	hl
	call	L1B47
	pop	af
	jp	nc,L2639
	call	L19A6
	call	L19F2
L2639:
	ret
;
L263A:
	call	L2608
	ld	a,(X803E)
	ld	l,a
	ld	h,000H
	push	hl
	call	L1B47
	pop	af
	jp	nc,L2688
	ld	a,(X803D)
	ld	l,a
	ld	h,000H
	push	hl
	call	L1B47
	pop	af
	jp	nc,L2682
	call	L109E
	pop	hl
	ld	a,l
	cp	000H
	jp	nz,L266B
	ld	hl,X803D
	bit	0,(hl)
	jp	nz,L2682
L266B:
	ld	a,(X8024)
	and	032H
	jp	nz,L2682
	ld	hl,X804B
	bit	0,(hl)
	jp	nz,L2682
	ld	a,(X8021)
	or	a
	jp	z,L268B
L2682:
	call	L19A6
	jp	L268B
;
L2688:
	call	L19E5
L268B:
	ret
;
L268C:
	ld	a,(X8021)
	cp	0FFH
	jp	z,L269F
	ld	a,(X8055)
	ld	b,a
	ld	a,(X8057)
	cp	b
	jp	z,L26A8
L269F:
	ld	a,(X8055)
	ld	(X8057),a
	call	L1998
L26A8:
	call	L204B
	pop	af
	jp	nc,L26BC
	ld	a,(X803E)
	ld	l,a
	ld	h,000H
	push	hl
	call	L2025
	jp	L26BF
;
L26BC:
	call	L263A
L26BF:
	ret
;
L26C0:
	call	L2524
	ld	a,(X8050)
	cp	004H
	call	nz,L268C
	ret
;
L26CC:
	call	L0AEB
	pop	af
	jp	nc,L2711
	ld	a,(X8055)
	ld	(X8056),a
	call	L2066
	ld	a,(X8050)
	cp	004H
	jp	z,L2714
	ld	a,(X8055)
	ld	(X8057),a
	call	L1998
	call	L204B
	pop	af
	jp	nc,L26FE
	ld	hl,00000H
	push	hl
	call	L2025
	jp	L2714
;
L26FE:
	ld	hl,00000H
	push	hl
	call	L1B47
	pop	af
	push	af
	call	c,L19A6
	pop	af
	call	nc,L19E5
	jp	L2714
;
L2711:
	call	L26C0
L2714:
	ret
;
L2715:
	ld	a,(X8055)
	and	00FH
	cp	00CH
	jp	nc,L2725
	call	L26CC
	jp	L2735
;
L2725:
	ld	hl,X8051
	res	7,(hl)
	ld	a,(X8050)
	cp	004H
	jp	z,L2735
	call	L19E5
L2735:
	ret
;
L2736:
	ld	a,(X8046)
	and	003H
	jp	nz,L2744
	call	L1AC6
	jp	L2752
;
L2744:
	ld	a,(X8050)
	cp	004H
	jp	nz,L274F
	call	L1AC6
L274F:
	call	L2715
L2752:
	ret
;
L2753:
	ld	a,(X8037)
	ld	b,a
	ld	a,(X8036)
	cp	b
	jp	z,L2767
	jp	c,L2767
	call	L10BA
	call	L05AE
L2767:
	ld	a,(X8036)
	ld	b,a
	ld	e,a
	ld	d,000H
	dec	de
	ld	hl,08025H
	add	hl,de
	ld	c,(hl)
L2774:
	ld	a,(X8037)
	cp	b
	jp	z,L2793
	jp	c,L2793
	ld	e,b
	ld	d,000H
	ld	hl,08025H
	add	hl,de
	ld	a,(hl)
	dec	hl
	ld	(hl),a
	ld	hl,0802DH
	add	hl,de
	ld	a,(hl)
	dec	hl
	ld	(hl),a
	inc	b
	jp	L2774
;
L2793:
	ld	hl,08025H
	ld	e,b
	ld	d,000H
	dec	de
	add	hl,de
	ld	(hl),c
	ld	hl,0802DH
	add	hl,de
	ld	(hl),000H
	ld	hl,X8037
	dec	(hl)
	ld	l,c
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L27AB:
	pop	hl
	ex	(sp),hl
	ld	c,l
	ld	hl,X8037
	inc	(hl)
	push	bc
	ld	l,c
	ld	h,000H
	push	hl
	ld	hl,00000H
	push	hl
	call	L02E0
	pop	bc
	push	bc
	ld	a,c
	add	a,007H
	ld	l,a
	ld	h,000H
	push	hl
	call	L035B
	call	L02E0
	pop	bc
	push	bc
	ld	a,c
	add	a,013H
	ld	l,a
	ld	h,000H
	push	hl
	call	L0362
	call	L02E0
	pop	bc
	ld	a,c
	add	a,00CH
	ld	l,a
	ld	h,000H
	push	hl
	call	L0369
	call	L02E0
	ret
;
L27EB:
	pop	hl
	ex	(sp),hl
	ld	b,l
	ld	e,007H
	ld	d,000H
L27F2:
	ld	hl,08025H
	add	hl,de
	dec	hl
	ld	a,(hl)
	cp	b
	jp	z,L2806
	ld	a,e
	cp	000H
	jp	z,L2806
	dec	e
	jp	L27F2
;
L2806:
	ld	l,e
	ld	h,000H
	ex	(sp),hl
	jp	(hl)    ; = ret with previous hl left in stack
;
L280B:
	pop	hl
	ex	(sp),hl
	ld	c,l
	ld	a,(X803A)
	cp	019H
	jp	nc,L281B
	ld	b,000H
	jp	L2822
;
L281B:
	push	bc
	call	L037B
	pop	hl
	pop	bc
	ld	b,l
L2822:
	push	bc
	ld	l,c
	ld	h,000H
	push	hl
	ld	l,b
	ld	h,000H
	push	hl
	call	L02E0
	pop	bc
	push	bc
	ld	a,c
	add	a,007H
	ld	l,a
	ld	h,000H
	push	hl
	call	L035B
	call	L02E0
	pop	bc
	push	bc
	ld	a,c
	add	a,013H
	ld	l,a
	ld	h,000H
	push	hl
	call	L0362
	call	L02E0
	pop	bc
	push	bc
	ld	a,c
	add	a,00CH
	ld	l,a
	ld	h,000H
	push	hl
	call	L0369
	pop	hl
	ld	a,l
	or	012H
	ld	l,a
	ld	h,000H
	push	hl
	call	L02E0
	pop	bc
	ld	a,(X803A)
	cp	018H
	jp	z,L288E
	jp	c,L288E
	ld	l,c
	ld	h,000H
	push	hl
	call	L27EB
	pop	hl
	ld	b,l
	ld	l,c
	ld	h,000H
	push	hl
	ld	e,b
	ld	d,000H
	dec	de
	ld	hl,0802DH
	add	hl,de
	ld	a,(hl)
	or	080H
	ld	l,a
	ld	h,000H
	push	hl
	call	L02F1
L288E:
	ret
;
L288F:
	ld	hl,X8039
	bit	0,(hl)
	jp	nz,L28B4
	call	L2753
	pop	hl
	ld	a,l
	ld	(X8038),a
	ld	h,000H
	push	hl
	call	L280B
	ld	a,000H
	ld	(X803A),a
	ld	a,0FFH
	ld	(X801E),a
	ld	hl,X8039
	set	0,(hl)
L28B4:
	ret
;
L28B5:
	ld	hl,X8039
	bit	0,(hl)
	jp	z,L28CE
	res	0,(hl)
	ld	a,(X8038)
	ld	l,a
	ld	h,000H
	push	hl
	call	L27AB
	ld	a,0FFH
	ld	(X801E),a
L28CE:
	ret
;
L28CF:
	ld	b,000H
	ld	a,(X8036)
	cp	001H
	jp	z,L28F9
	jp	c,L28F9
	ld	de,00001H
L28DF:
	ld	hl,0802DH
	add	hl,de
	dec	hl
	ld	a,(hl)
	cp	b
	jp	z,L28ED
	jp	c,L28ED
	ld	b,a
L28ED:
	ld	a,(X8036)
	dec	a
	cp	e
	jp	z,L28F9
	inc	e
	jp	L28DF
L28F9:
	ret
;
L28FA:
	ld	hl,0802DH
	ld	de,00005H
	add	hl,de
	dec	hl
	ld	a,(hl)
	ld	(X805F),a
	ld	hl,0802DH
	ld	de,00006H
	add	hl,de
	dec	hl
	ld	a,(hl)
	ld	(X8060),a
	ld	hl,0802DH
	ld	de,00007H
	add	hl,de
	dec	hl
	ld	a,(hl)
	ld	(X8061),a
	ld	a,000H
	ld	(X8062),a
L2923:
	ld	a,(X805F)
	cp	b
	jp	z,L292D
	jp	nc,L294D
L292D:
	add	a,00CH
	ld	(X805F),a
	ld	a,(X8060)
	or	a
	jp	z,L293E
	add	a,00CH
	ld	(X8060),a
L293E:
	ld	a,(X8061)
	or	a
	jp	z,L2923
	add	a,00CH
	ld	(X8061),a
	jp	L2923
;
L294D:
	ld	a,(X805F)
	cp	b
	jp	c,L2974
	sub	00CH
	ld	(X805F),a
	ld	a,(X8060)
	or	a
	jp	z,L2965
	sub	00CH
	ld	(X8060),a
L2965:
	ld	a,(X8061)
	or	a
	jp	z,L294D
	sub	00CH
	ld	(X8061),a
	jp	L294D
;
L2974:
	ld	a,b
	ld	hl,X805F
	sub	(hl)
	cp	003H
	jp	c,L2984
	ld	a,(X805F)
	jp	L29B7
;
L2984:
	ld	a,(X8060)
	or	a
	jp	z,L299B
	ld	a,b
	ld	hl,X8060
	sub	(hl)
	cp	003H
	jp	c,L299B
	ld	a,(X8060)
	jp	L29B7
;
L299B:
	ld	a,(X8061)
	or	a
	jp	z,L29B2
	ld	a,b
	ld	hl,X8061
	sub	(hl)
	cp	003H
	jp	c,L29B2
	ld	a,(X8061)
	jp	L29B7
;
L29B2:
	ld	a,(X805F)
	sub	00CH
L29B7:
	ld	hl,0802DH
	ld	b,000H
	add	hl,bc
	dec	hl
	ld	(hl),a
	ret
;
L29C0:
	ld	a,(X8022)
	cp	0FFH
	jp	nz,L2A17
	ld	a,(X8055)
	srl	a
	srl	a
	srl	a
	srl	a
	and	007H
	ld	d,a
	ld	a,(X8055)
	and	00FH
	ld	e,a
	ld	a,b
	sub	006H
	sub	e
	ld	e,a
L29E1:
	ld	a,e
	cp	00BH
	jp	z,L29F0
	jp	c,L29F0
	sub	00CH
	ld	e,a
	jp	L29E1
;
L29F0:
	push	bc
	ld	hl,02A37H
	ld	c,d
	sla	c
	ld	b,000H
	add	hl,bc
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	l,e
	ld	h,000H
	add	hl,bc
	ld	bc,02B1FH
	add	hl,bc
	ld	a,(X803A)
	sub	(hl)
	pop	bc
	push	bc
	ld	hl,0802DH
	ld	b,000H
	add	hl,bc
	dec	hl
	ld	(hl),a
	pop	bc
	jp	L2A1E
;
L2A17:
	push	bc
	push	de
	call	L28FA
	pop	de
	pop	bc
L2A1E:
	ld	a,(X8038)
	ld	l,a
	ld	h,000H
	push	hl
	ld	hl,0802DH
	ld	b,000H
	add	hl,bc
	dec	hl
	ld	a,(hl)
	or	080H
	ld	l,a
	ld	h,000H
	push	hl
	call	L02F1
	ret
;
	db	000H, 000H, 00CH, 000H
	db	018H, 000H, 024H, 000H
	db	030H, 000H, 03CH, 000H
	db	048H, 000H
;
L2A45:
	call	L28CF
	ld	a,(X8046)
	and	003H
	jp	nz,L2A5D
	ld	a,(X801F)
	cp	000H
	jp	nz,L2A6C
	ld	b,000H
	jp	L2A6C
;
L2A5D:
	ld	a,(X8055)
	and	00FH
	cp	00CH
	jp	z,L2A6C
	jp	c,L2A6C
	ld	b,000H
L2A6C:
	push	bc
	ld	a,(X8038)
	ld	l,a
	ld	h,000H
	push	hl
	call	L27EB
	pop	hl
	pop	bc
	ld	c,l
	ld	a,(X803A)
	cp	b
	jp	z,L2ABC
	ld	a,b
	ld	(X803A),a
	cp	018H
	jp	z,L2AA3
	jp	c,L2AA3
	push	bc
	ld	a,(X8038)
	ld	l,a
	ld	h,000H
	push	hl
	ld	hl,00000H
	push	hl
	call	L02E0
	pop	bc
	call	L29C0
	jp	L2AD0
;
L2AA3:
	ld	a,(X8038)
	ld	l,a
	ld	h,000H
	push	hl
	ld	hl,0802DH
	ld	e,c
	ld	d,000H
	add	hl,de
	dec	hl
	ld	l,(hl)
	ld	h,000H
	push	hl
	call	L02F1
	jp	L2AD0
;
L2ABC:
	ld	a,b
	cp	018H
	jp	z,L2AD0
	jp	c,L2AD0
	ld	a,(X8020)
	cp	0FFH
	jp	nz,L2AD0
	call	L29C0
L2AD0:
	ret
